{$C MOVEABLE DEMANDLOAD DISCARDABLE}
{$R NUM.RES}

unit Exper;

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Exper                                                          *}
{*                                                                           *}
{*  This Unit contains procedure sets number of experiments                  *}
{*  and procedures to choose methods writing results of experiments to file. *}
{*                                                                           *}
{*****************************************************************************}

interface

uses WinDos,Strings,ODialogs,Objects,OWindows,WinTypes, WinProcs,OStdWnds,
     OStddlgs,OPrinter ,win31,WinCrt,
     Deklar,Print,PrintObj,Consobj,Tools,FileGen;


const
 id_BN2 = 102;
 id_LB = 101;
type


  PExperN = ^TExperN;
  TExperN= object(TWindow)
    Edit: PEdit;
    Path: Strg1;
    constructor Init(AParent: PWindowsObject; ATitle: PChar;M: HMenu);
  end;


  PExper = ^TExper;
  TExper= object(TWindow)
    Path: Strg1;
    How: HowFile;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure WriteSched(n,last: Boolean;FName: PChar; time : Real);
  end;


implementation


constructor TExper.Init(AParent: PWindowsObject; ATitle: PChar);
 begin
  Inherited Init(AParent,ATitle);
  How:= over;
 end;

procedure TExper.WriteSched(n,last: Boolean;FName: PChar; time : Real);

 const
  HowToWrite:SetupSaveInf=(speed:1;exect:1;ready:1;ddate:1;numpr:1;Indce:1;Prec :1;ofile:'dane.dta');
 var
  F: text;
  S: array[0..fsPathName+27] of Char;
  cm: Integer;
  FileOK: Boolean;
  Nazwa: PChar;
  ECmax,Etime:Real;
procedure WriteDataFile;
 begin
   write(F,'Number of experiments: ');
   writeln(F,Experiment.E);
   writeln(F,'');
   write(F,'File Name:  ');
   if FName = nil then writeln(F,'editor') else
   writeln(F,FName);
   writeln(F,'');
   WriteFile(F,HowToWrite);
   writeln(F,'');
   writeln(F,'Nr   Cmax/Lmax    Memory        Time     ');
   writeln(F,'============================================');
   writeln(F,'');
   Close(F)
 end;

begin
  case How of
     over:
       begin
        Assign(F,Path);
        if n then
         begin
          Rewrite (F);
          WriteDataFile;
        end;
       end;

     add:
      begin
       Assign(F,Path);
        if n then
          begin
           Append (F);
           writeln(F,'');
           WriteDataFile;
         end;
      end;

     newF:
      begin
       FileOk:=False;
       if n then
       while not FileOK do
        begin
         cm:= Application^.ExecDialog(New(PInputDialog,Init(Parent,'Input Box File Name',
            'File :',Path,fsPathName)));
         if cm<>idOK then  Exit;
         Assign(F,Path);
         {$I-}
         Reset(F);
         {$I+}
         FileOK:=(IoResult<>0);
         if not FileOK then
          begin
           Nazwa:= Path;
           WVSPrintF(S, 'File   "%s"  exists.   Overwrite it ?', Nazwa);
           cm:=MessageBox(0,S,nil,mb_YesNoCancel);
           Case cm Of
             idYes :     Begin
                           Rewrite(F);
                           FileOk:=True;
                         End;
             idCancel :  Begin
                           Close(F);
                           Exit;
                         End;
             idNo :      Close(F);
           End; {Case}
          end;
        end;
       if not n then Assign(F,Path) else
        begin
         Rewrite(F);
         WriteDataFile;
        end;
      end;
     end;
  Append(F);
  if fullform then writeln(F,Experiment.E-Experiment.DecE+1,'       ',sched.C:5:3,'              ',memory,
                '       ',time:5:5);
  EverageCmax:=EverageCmax+sched.C;
  EverageExecTime:=EverageExecTime+time;
  if last and not fullform then
  begin
   ECmax:=EverageCmax/Experiment.E;
   ETime:=EverageExecTime/Experiment.E;
   writeln(F,'Average Cmax = ',ECmax:7:4);
   writeln(F,'Average Execution Time = ',Etime:7:4);
  end;
 Close(F);
end;



{*********   TExper      ***********************************************}


constructor TExperN.Init(AParent: PWindowsObject; ATitle: PChar; M: HMenu);
type
 Tran=record
       i: Wrd;
      end;
var
  i: Integer;
  TempStat : PStatic;
  TempBtn: PButton;
  ch: Wrd;
  S: String;
  D: PDialog;
  code: Integer;
  TransferI: Tran;

begin
  Str(Experiment.E,S);
  StrPCopy(ch,S);
  StrCopy(TransferI.i,ch);
  D:=New(PDialog,Init(AParent,'D'));
  Edit := New(PEdit, InitResource(D, id_LB,20));
  D^.TransferBuffer:=@TransferI;
  if  Application^.ExecDialog(D)<>id_Cancel then
   begin
   with Experiment do
    begin
     ch:=TransferI.i;
     s:=StrPas(ch);
     Val(s,i,code);
     E:=i;
     DecE:=E;
     Str(E,S);
     S:=ConCat('Number  ',S);
     StrPCopy(ch,S);
    end;
   ModifyMenu(GetSubMenu(M, 4),0,mf_ByPosition or mf_String,140,ch);
  end;
end;

end.

