{$I PCoption}

unit FileGen;

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Filegen                                                        *}
{*                                                                           *}
{*  This unit contains procedures for file works & services. These are:      *}
{*  read_file_task     reads data from disc,                                 *}
{*  write_file_task    writes data to disc,                                  *}
{*                                                                           *}
{*****************************************************************************}

{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses WinDos,WinTypes,Objects,WinProcs,Strings,OStdDlgs,
     OWindows,ODialogs,OStdWnds,Deklar,Tools,TaskGen,ConsObj,
     PrintObj;



 procedure EnableItemAlg(const Enable: Word);
 procedure WriteFile(var tx: text;How:SetupSaveInf);

type

  PMyFileWindow = ^TMyFileWindow;
  TMyFileWindow = object(TFileWindow)
   procedure ReadFileTask(name:PChar; var gen:generate; var tasks:task_rec; var comp:comp_rec; var kp:ig;var TypeFile: TypeF);
   procedure WriteFileTask(name:PChar; gen:generate; tasks:task_rec; comp:comp_rec; kp:ig;How:SetupSaveInf);
  end;




{procedure ReadFileTask(name:string; var gen:generate; var tasks:task_rec; var comp:comp_rec; var kp:ig);
	This procedure reads data from disc file
	name - file name,
	gen  - record describing method of generation of data,
	task - tasks set record,
	comp - processors set record,
	kp   - number of processors for execution of widest multiprocessor tasks}

{procedure WriteFileTask(name:string; gen:generate; tasks:task_rec; comp:comp_rec; kp:ig;How:SetupSaveInf);}
{	This procedure writes data to disc
	name - file name,
	gen  - record describing method of generation of data,
	task - tasks set record,
	comp - processors set record,
	kp   - number of processors for execution of widest multiprocessor tasks}


implementation

 procedure EnableItemAlg(const Enable: Word);
  var
   Menu: HMenu;
  begin
  Menu:=PMyFileWindow(Application^.MainWindow)^.Attr.Menu;
   EnableMenuItem(Menu,id_Fix,Enable);
   EnableMenuItem(Menu,id_Kproc,Enable);
   EnableMenuItem(Menu,id_MKproc,Enable);
   EnableMenuItem(Menu,id_MCof,Enable);
   EnableMenuItem(Menu,id_Naug,Enable);
   EnableMenuItem(Menu,id_KGLP,Enable);
   EnableMenuItem(Menu,id_CofGra,Enable);
   EnableMenuItem(Menu,id_Hu,Enable);
   EnableMenuItem(Menu,id_Alg520,Enable);
   EnableMenuItem(Menu,id_AlgIPL,Enable);
   EnableMenuItem(Menu,id_Alg1,Enable);
   EnableMenuItem(Menu,id_Alg2,Enable);
   EnableMenuItem(Menu,id_Alg3,Enable);
   EnableMenuItem(Menu,id_Alg4,Enable);
  end;




procedure TMyFileWindow.ReadFileTask(name: PChar; var gen:generate; var tasks:task_rec; var comp:comp_rec; var kp:ig;
                                     var TypeFile: TypeF);

var
   tx: text;
   s:  String;


procedure blank(var s:String);{ deletes beginning blanks}
 begin
   while ((s[1]=' ') or (s[1]=chr(9))) and (s<>'') do
      delete(s,1,1);
 end;

procedure cutb(var s:string); {the same as butfirst bf}
 begin
   while (s[1]<>' ') and (s[1]<>chr(9)) and (s<>'') do
      delete(s,1,1);
 end;


function cmp(var a:string; b:string): Boolean;
 var
   i:ig;
  begin
   i:=Pos(b,a);
   if i<>0 then
    begin
     delete(a,1,i+length(b)-1);
     cmp:=TRUE;
    end
   else
    cmp:=FALSE;
   blank(a);
  end;

 procedure File_Error(Say: Strg1);
  const
   S: array[0..150] of Char ='ERROR: inconsistency of data in Data Set Boxes.    ';
  var
   S1 : array[0..150] of Char ;
  begin
   StrCopy(S1,S);
   StrCat(S1,Say);
   MessageBox(HWindow,S1,nil,MB_IconExclamation + MB_OK);
  end;

function line(var s:string):integer;
 const
  W: Strg1=#13#10;
 var
  i:ig;

 begin
  line:=0;
    if eof(tx) then
     begin
      StrPCopy(W,'Unexpected end of file');
      File_Error(W);
      line:=-1;
      Exit
     end;
    if eof(tx) then exit;
    repeat
      readln(tx,s);
      blank(s);
   until s[1]<>';';
   for i:=1 to length(s) do
      s[i]:=UpCase(s[i]);
 end;

procedure fillgen(s:string;var gd:gendata);
var
   i: ig;
begin
   if cmp(s,'RND01') then
         gd.form:=rnd1;
   if cmp(s,'RNDNORM') then
         gd.form:=rndnorm;
   if cmp(s,'RNDEXP') then
         gd.form:=rndexp;
	if cmp(s,'CONST') then
			gd.form:=cons;
   blank(s);
   valr(s,gd.par1,i);
   cutb(s);
   blank(s);
   valr(s,gd.par2,i);
end;



procedure pproc(var gen:generate;var comp:comp_rec);
var
   s:        String;
   m,k,i,j:  ig;
   x:        Boolean;
   r:        Real;
   t_proc:   comp_proc;

begin

 x:=false;
 while (not eof(tx)) and (not x) do
  begin
   if line(s)<0 then
    begin
     is_act_descr:=false;
     Exit;
    end;
   x:=cmp(s,'KP=');
  end;
 vali(s,kp,i);
 x:=false;
 while (not eof(tx)) and (not x) do
  begin
   if line(s)<0 then
    begin
     is_act_descr:=false;
     Exit;
    end;
   x:=cmp(s,'M=');
  end;
 vali(s,m,i);
 comp.nr_comp_proc:=m;
 line(s);
 if s[1]='S' then
   fillgen(s,gen.speed_g)
 else  {Data}
   gen.speed_g.form:=data;
  with comp do
    begin
     for i:=1 to m do
      begin
       new(comp_pr[i]);
       with comp_pr[i]^ do
        begin
         proc_nr:=i;
         pc:=0;
         nr_comp:=1;
         speed:=0;
         comp_a[1].pr_nr:=i;
         comp_a[1].beg_time:=0;
         if (((i mod kp)=1) or (kp=1)) then
          begin
           vali(s,j,k);
           cutb(s);
           blank(s);
           vali(s,speed,k);
           comp_a[1].comp_speed:=speed;
           if (i div kp) < (((m+1) div kp)-1) then line(s);
          end
         else
          begin
           speed:=comp_pr[((i-1)div kp)*kp+1]^.speed;
           comp_a[1].comp_speed:=speed;
          end;
        end;
      end;
     for i:=1 to m-1 do
     for j:=i+1 to m do
     if comp_pr[j]^.speed>comp_pr[i]^.speed then
      begin
       t_proc:=comp_pr[i]^;
       comp_pr[i]^:=comp_pr[j]^;
       comp_pr[j]^:=t_proc;
      end;
     for i:=1 to m do with comp_pr[i]^ do
      begin
       proc_nr:=i;
       comp_a[1].pr_nr:=i;
      end;
    end;
  if is_act_descr then  is_act_proc:=true;
end;


procedure ptask(var gen:generate; var tasks:task_rec;var kp:ig);
 var
   s:           String;
   i,i1,i2,j,k: ig;
   rd,x:        Boolean;
   W:           Strg1;

begin
 line(s);
 x:=cmp(s,'KP=');
 vali(s,kp,i);
 with tasks do with gen do
  begin
   line(s);
   x:=cmp(s,'N=');
   vali(s,n,j);
   for i:=1 to n do task_v[i]:=nil;
   line(s);
   task_p.form:=data;
   task_r.form:=data;
   task_d.form:=data;
   task_k.form:=data;
   task_ded.form:=data;
   i:=0;
   while (s[1] in ['P','R','D','K','Q']) and (i<5) do
    begin
     case s[1] of
      'P' : fillgen(s,task_p);
      'R' : fillgen(s,task_r);
      'D' : fillgen(s,task_d);
      'K' : fillgen(s,task_k);
      'Q' : fillgen(s,task_ded);
     end;
     i:=i+1;
     if i<5 then line(s);
    end;
   if i=5 then TypeFile:=mn else TypeFile:=fi;
   rd:=(task_p.form=data) or (task_r.form=data) or (task_d.form=data) or (task_k.form=data) or (task_ded.form=data);
   for i:=1 to n do   {make tasks}
    begin
     if rd then
      begin
       vali(s,k,j);
       cutb(s);
       blank(s);
      end
     else
       k:=i;
     new(task_v[k]);
     with task_v[k]^ do
      begin
       nr:=i;
       dedication:=[];
       if task_p.form=data then
        begin
         valr(s,tasktime,j);
         cutb(s); blank(s);
        end;
       if task_r.form=data then
        begin
         valr(s,rdytime,j);
         cutb(s); blank(s);
        end;
       if task_d.form=data then
        begin
         valr(s,ddate,j);
         cutb(s); blank(s);
        end;
       if  task_k.form=data then
        begin
         vali(s,prcsnum,j);
         cutb(s);blank(s);
         end;
       if task_ded.form=data then
        begin
         if task_k.form<>data then
          begin
           if is_act_descr then
            begin
             StrPCopy(W,'random number and fixed set of required processors/resources');
              File_Error(W);
            end;
           is_act_descr:=false;
          end;
         if readset(s,dedication)<0 then
          begin
           if is_act_descr then
            begin
             StrPCopy(W,'Wrong definition of set in some task');
             File_Error(W);
             end;
           is_act_descr:=false;
          end;
         if cardinality(dedication)<>prcsnum then
          begin
           if is_act_descr then
            begin
             StrPCopy(W,'Less processors dedicated to some task then required');
             File_Error(W);
            end;
           is_act_descr:=false;
          end;
        end
       else if (task_ded.form=cons) and (task_ded.par1<>0) then
        begin
         if (gen.task_ded.par1>comp.nr_comp_proc) or (gen.task_ded.par1<0) then
          begin
           if is_act_descr then
            begin
             StrPCopy(W,'Constant should be positive less than or equal to the number of machines');
             File_Error(W);
            end;
           is_act_descr:=false;
          end;
         if not (((gen.task_k.form=data) and (prcsnum=1)) or ((gen.task_k.form=cons) and (gen.task_k.par1=1)))
         then
          begin
           if is_act_descr then
            begin
             StrPCopy(W,'You can not execute task on more than one processor and dedicate only 1 processor to it');
             File_Error(W);
            end;
           is_act_descr:=false;
          end;
        end
      end;
     if ((i<n) and rd) then line(s);
    end;       (* for i:= *)
    i:=1;
    while i<n do
     begin
      inc(i);
      if task_v[i]=nil then
       begin
        if is_act_descr then
         begin
          StrPCopy(W,'Not enough tasks specified');
          File_Error(W);
          end;
         is_act_descr:=false;
       end;
     end;
  end;
 if is_act_descr then is_act_task:=True;
end;

 procedure psucc(var gen:generate; var tasks:task_rec);
  var
    s:          String;
    i,j,k,l,m:  ig;
    tab:        succtab;
    sent:       ptrprem;
    x:          Boolean;
    W:          Strg1;

  begin
   x:=false;
   while (not eof(tx)) and (not x) do
    begin
     if line(s)<0 then
      begin
       is_act_descr:=false;
       exit;
      end;
     x:=pos('END',s)>0;
     x:=x or (pos('CHAIN',s) >0);
     x:=x or (pos('INTREE',s) >0);
     x:=x or (pos('OUTTREE',s) >0);
     x:=x or (pos('PREC',s) >0); {word 'PREC' precedes given precedence constraints which are fixed}
    end;
   if (eof(tx)) and (not x) then
    begin
     StrPCopy(W,'unexpected end of file');
     File_Error(W);
     is_act_descr:=false;
     exit;
    end;
   with tasks do
    begin
     for i:=1 to n do
        task_v[i]^.next:=nil;
     if cmp(s,'END') then
      begin
       gen.succ_g:=nosucc;
       exit;
      end;
     if cmp(s,'CHAIN') then
      begin
       gen.succ_g:=chain;
       gen_prem(gen,tasks);
       exit;
      end;
     if cmp(s,'INTREE') then
      begin
       gen.succ_g:=intree;
       gen_prem(gen,tasks);
       exit;
      end;
     if cmp(s,'OUTTREE') then
      begin
       gen.succ_g:=outtree;
       gen_prem(gen,tasks);
       exit;
      end;
     if cmp(s,'PREC') then
     begin
      gen.succ_g:=datas;
      line(s);
      while not cmp(s,'END') do
      begin
       vali(s,k,j);
       cutb(s);
       blank(s);
       vali(s,m,j);
       new(sent);
       with task_v[k]^ do
        begin
         sent^.next:=next;
         sent^.nrprem:=m;
         next:=sent;
        end;
       line(s);
      end;
     end;
    end;
  { if is_act_descr then }is_act_succ:=true;
  end;



  begin
    dispose_data_structures;
    init_data_structures;
    Assign(tx,name);
    Reset(tx);
    is_act_descr:=true;{ trial value of flag if still true at end then OK}
    pproc(gen,comp);
    Close(tx);
    Reset(tx);
    ptask(gen,tasks,kp);
    psucc(gen,tasks);
    is_act_data:=(is_act_task) and (is_act_proc) and ((gen.succ_g=nosucc) or ((gen.succ_g<>nosucc) and (is_act_succ)));
    if not is_act_data then EnableItemAlg(mf_Disabled + mf_Grayed) else EnableItemAlg(mf_Enabled);
    Close(tx);      { ReadFileTask}
  end;


 procedure WriteFile(var tx: text;How:SetupSaveInf);
   var
    wd,p,r,d,k,q,knc: Boolean;
    i: Integer;
    nx:       ptrprem;


 procedure Write_Rnd(g:gendata);
  begin
   case g.form of
     rnd1 : writeln(tx,'rnd01  ',g.par1:10:3);
     rndnorm : writeln(tx,'rndnorm  ',g.par1:10:3);
     rndexp : writeln(tx,'rndexp  ',g.par1:10:3,g.par2:13:3);
     cons : writeln(tx,'const  ',g.par1:10:3);
   end;
  end;


   begin
    with tasks do with comp do with gen do
    begin
     writeln(tx,';');
     writeln(tx,';   T A S K S');
     writeln(tx,';');
     writeln(tx,';  Number of k processors');
     writeln(tx,'    kp=',kp);
     writeln(tx,'; Number of tasks');
     writeln(tx,'    n=',n);
     if task_p.form<>data then p:=How.exect=0
     else p:=TRUE;
     if task_r.form<>data then r:=How.ready=0
     else r:=TRUE;
     if task_d.form<>data then d:=How.ddate=0
     else d:=TRUE;
     if task_k.form<>data then k:=How.numpr=0
     else k:=TRUE;
     if task_ded.form<>data then q:=How.indce=0
     else q:=TRUE;
     if not p then
      begin
       WriteData1(tx,'       p  ');
       Write_Rnd(task_p)
      end;
     if not r then
      begin
      WriteData1(tx,'       r  ');
       Write_Rnd(task_r)
      end;
     if not d then
      begin
       WriteData1(tx,'       d  ');
       Write_Rnd(task_d)
      end;
     if not k then
      begin
       WriteData1(tx,'       k  ');
       Write_Rnd(task_k);
      end;
     if not q then
      begin
       WriteData1(tx,'       q  ');
       Write_Rnd(task_ded);
      end;
     if p or r or d or k or q then
      begin
       WriteData1(tx,';  Task #       ');
       if p then WriteData1(tx,'p         ');
       if r then WriteData1(tx,'r         ');
       if d then WriteData1(tx,'d         ');
       if k then WriteData1(tx,'k         ');
       if q then WriteData1(tx,'q');
       writeln(tx);
       for i:=1 to n do
        begin
         WriteData3(tx,'      ',i,'   ');
         if p then WriteData2(tx,task_v[i]^.tasktime,'    ');
         if r then WriteData2(tx,task_v[i]^.rdytime,'    ');
	 if d then WriteData2(tx,task_v[i]^.ddate,'        ');
         if k then WriteData2(tx,task_v[i]^.prcsnum,'       ');
         if q then printset(tx,task_v[i]^.dedication);
         writeln(tx);
        end;
      end;
     writeln(tx,';');
     writeln(tx,';   P R O C E S S O R S');
     writeln(tx,';');
     writeln(tx,';  Number of processors');
     writeln(tx,'    m=',nr_comp_proc);
     if speed_g.form<>data then wd:=How.speed=0;
     if (speed_g.form=data) or wd then
      begin
       writeln(tx,';   Processor #    Speed');
       for i:=1 to nr_comp_proc do if (((i mod kp)=1) or (kp=1)) then
        writeln(tx,'    ',i,'        ',comp_pr[i]^.speed:8);
      end
     else
      begin
       WriteData1(tx,'    speed  ');
       Write_Rnd(speed_g);
      end;
     if succ_g<>nosucc then
      begin
       writeln(tx,';');
       writeln(tx,';   S U C C E D I N G   T A S K S');
       writeln(tx,';');
       if succ_g<>datas then wd:=How.Prec=0;
      end;
     if ((succ_g=datas) or wd ) and (succ_g<>nosucc) then
      begin
       writeln(tx,'; Predeccesor     Succesor');
       for i:=1 to n do
        begin
         nx:=task_v[i]^.next;
         while nx<>nil do
          begin
     	   writeln(tx,'     ',i,nx^.nrprem:8);
	   nx:=nx^.next;
          end;
        end;
     end
     else if succ_g<>nosucc then
      case succ_g of
        chain : writeln(tx,'   chain');
        intree : writeln(tx,'    intree');
        outtree : writeln(tx,'    outtree');
       end;
     writeln(tx,'end');
   end;
  end;



 procedure TMyFileWindow.WriteFileTask(name:PChar; gen:generate; tasks:task_rec; comp:comp_rec; kp:ig;How:SetupSaveInf);
  var
     plik1,tx: text;
     cm:       Word;
     i:        ig;
     nx:       ptrprem;
     ch:       Char;
     Where,Nazwa,inf: PChar;
     S: array[0..fsPathName+27] of Char;
     fileOk,wd,p,r,d,k,q,knc: Boolean;

  procedure Write_Rnd(g:gendata);
  begin
   case g.form of
     rnd1 : writeln(tx,'rnd01  ',g.par1:10:3);
     rndnorm : writeln(tx,'rndnorm  ',g.par1:10:3);
     rndexp : writeln(tx,'rndexp  ',g.par1:10:3,g.par2:13:3);
     cons : writeln(tx,'const  ',g.par1:10:3);
	  end;
  end;

  begin
   knc:=false;
   GetMem(Where,80);
   Nazwa := FileExpand(Where,name);
   Assign(tx, Nazwa);
   {$I-}
   Reset(tx);
   {$I+}
   Fileok:=(IoResult<>0);
   FileInEdit:= False;
   while not fileOk do
    begin
     WVSPrintF(S, 'File   "%s"  exists.   Overwrite it ?', Nazwa);
     cm:=MessageBox(HWindow,S,nil,mb_YesNoCancel);
     if cm=idYes then
      begin
       Erase(tx);
       FileOk:= True;
       inf:='The contents of editor will be changed.';
       cm:=MessageBox(HWindow,inf,nil,mb_OkCancel + mb_IconInformation);
       if cm=idCancel then Exit;
       if cm=idOK then
        begin
         FileInEdit:= True;
         EnableMenuItem(GetMenu(HWindow),cm_FileSave,mf_Enabled);
         EnableMenuItem(GetMenu(HWindow),cm_FileSaveAs,mf_Enabled);
         EnableMenuItem(GetMenu(HWindow),cm_Print,mf_Enabled);
        end;
      end
     else if cm=idNo then
      begin
       Close(tx);
       cm:= Application^.ExecDialog(New(PInputDialog,Init(@Self,'Input Box File Name',
                   'File :',Nazwa,fsPathName)));
       if cm<>idOK then Exit;
       Assign(tx,Nazwa);
       {$I-}
       Reset(tx);
       {$I+}
       fileOK:=(IoResult<>0);
      end
     else if cm=idCancel then
      begin
       Close(tx);
       Exit
      end
    end;

   Assign(tx,Nazwa);
   Rewrite(tx);
   WriteFile(tx,How);
 {   with tasks do with comp do with gen do
    begin
     writeln(tx,';');
     writeln(tx,';   T A S K S');
     writeln(tx,';');
     writeln(tx,';  Number of k processors');
     writeln(tx,'    kp=',kp);
     writeln(tx,'; Number of tasks');
     writeln(tx,'    n=',n);
     if task_p.form<>data then p:=How.exect=0
     else p:=TRUE;
     if task_r.form<>data then r:=How.ready=0
     else r:=TRUE;
     if task_d.form<>data then d:=How.ddate=0
     else d:=TRUE;
     if task_k.form<>data then k:=How.numpr=0
     else k:=TRUE;
     if task_ded.form<>data then q:=How.indce=0
     else q:=TRUE;
     if not p then
      begin
       WriteData1(tx,'       p  ');
       Write_Rnd(task_p)
      end;
     if not r then
     begin
      WriteData1(tx,'       r  ');
       Write_Rnd(task_r)
      end;
     if not d then
      begin
       WriteData1(tx,'       d  ');
       Write_Rnd(task_d)
      end;
     if not k then
      begin
       WriteData1(tx,'       k  ');
       Write_Rnd(task_k);
      end;
     if not q then
      begin
       WriteData1(tx,'       q  ');
       Write_Rnd(task_ded);
      end;
     if p or r or d or k or q then
      begin
       WriteData1(tx,';  Task #       ');
       if p then WriteData1(tx,'p         ');
       if r then WriteData1(tx,'r         ');
       if d then WriteData1(tx,'d         ');
       if k then WriteData1(tx,'k         ');
       if q then WriteData1(tx,'q');
       writeln(tx);
       for i:=1 to n do
        begin
         WriteData3(tx,'      ',i,'   ');
         if p then WriteData2(tx,task_v[i]^.tasktime,'    ');
         if r then WriteData2(tx,task_v[i]^.rdytime,'    ');
	 if d then WriteData2(tx,task_v[i]^.ddate,'        ');
         if k then WriteData2(tx,task_v[i]^.prcsnum,'       ');
         if q then printset(tx,task_v[i]^.dedication);
         writeln(tx);
        end;
      end;
     writeln(tx,';');
     writeln(tx,';   P R O C E S S O R S');
     writeln(tx,';');
     writeln(tx,';  Number of processors');
     writeln(tx,'    m=',nr_comp_proc);
     if speed_g.form<>data then wd:=How.speed=0;
     if (speed_g.form=data) or wd then
      begin
       writeln(tx,';   Processor #    Speed');
       for i:=1 to nr_comp_proc do if (((i mod kp)=1) or (kp=1)) then
        writeln(tx,'    ',i,'        ',comp_pr[i]^.speed:8);
      end
     else
      begin
       WriteData1(tx,'    speed  ');
       Write_Rnd(speed_g);
      end;
     if succ_g<>nosucc then
      begin
       writeln(tx,';');
       writeln(tx,';   S U C C E D I N G   T A S K S');
       writeln(tx,';');
       if succ_g<>datas then wd:=How.Prec=0;
      end;
     if ((succ_g=datas) or wd ) and (succ_g<>nosucc) then
      begin
       writeln(tx,'; Predeccesor     Succesor');
       for i:=1 to n do
        begin
         nx:=task_v[i]^.next;
         while nx<>nil do
          begin
     	   writeln(tx,'     ',i,nx^.nrprem:8);
	   nx:=nx^.next;
          end;
        end;
     end
     else if succ_g<>nosucc then
      case succ_g of
        chain : writeln(tx,'   chain');
        intree : writeln(tx,'    intree');
        outtree : writeln(tx,'    outtree');
       end;
     writeln(tx,'end');
   end;             }

   Close(tx);
   FreeMem(Where,80);
  end;

end.