{$I Pcoption}
unit Fix;

interface
uses WinDos,Deklar,Tools;

procedure Fixs(var tasks:task_rec;var comp:comp_rec;var sched:schedul_rst;var workt:real;kp:ig);
{ Parametrs given:
     task - tasks set
     comp - processor set
     inf  - display full information about schedule
            'y' - yes
            'n' - no
  Parametrs returned:
     sched - schedule description
     workt - how long schedule was computed}

implementation


procedure Fixs(var tasks:task_rec;var comp:comp_rec; var sched:schedul_rst;var workt:real; kp:ig);
const MaxReal=1e38;
type
 wezptr=^wezel;
 wezel=record
        task,processors_used:fs;
        next:wezptr
       end;
 vector_ptr=^vect;
 vect=array[1..MaxN] of real;
 sequence_pointer=^feasible_element;
 feasible_element=record
                   start,finish:real;
                   l,u:real;
                   feasible_set:wezptr;
                   that_follows:sequence_pointer;
                   PC:vector_ptr;
                   next:sequence_pointer;
                  end;



var upper,lower,Cmax:real;
    s_j:wezptr;
    PC_req:vector_ptr;
    sequence,best,tmp_r:sequence_pointer;
    Pt,max_PC:real;
    s:fs;
    headA,headB:wezptr;
    i,i1:integer;
    hr,mn,sc,sc100:word;
    ch:char;
    completion:vector_ptr;
    number_of_feasible_sets:integer;
    number_of_search_tree_nodes:integer;
    number_of_possible_branches:longint;
    number_of_branches_at_level0:integer;
    pustak:fs;
    ex:boolean;
    bx,by:byte;

procedure pop_tset(var tse,proc:fs;var head:wezptr);
var tmp:wezptr;
begin
 tse:=head^.task;
 proc:=head^.processors_used;
 tmp:=head^.next;
 dispose(head);
 head:=tmp;
end;

procedure push_tset(tse,proc:fs;var head:wezptr);
var tmp:wezptr;
    bx,by:byte;

begin
 if memP(sizeof(tmp^)) then
 new(tmp);
 Inc(memory,sizeof(tmp^));
 tmp^.task:=tse;
 tmp^.processors_used:=proc;
 tmp^.next:=head;
 head:=tmp;
end;


procedure stackstate(okno:boolean;head:wezptr);
var tmp:wezptr;
    i:integer;
    backx,backy:byte;
    s:string;
    f:text;
    pustak:char;
begin
 tmp:=head;
 i:=1;
 while not(tmp=nil) do
  begin
    i:=i+1;
    tmp:=tmp^.next
  end;
 number_of_feasible_sets:=i-1;
end;

procedure nastepny1prosze(nowindex:integer;tse,not_free:fs);
{nowindex-task to be added,free -ile jeszcze procesorow wolnych,
tse-actuall feasible set of processors }
var i:integer;
    tsk:fs;
begin
 with tasks do
  begin
   if (not_free*task_v[nowindex]^.dedication=[]) then
    begin
     tse:=tse+[nowindex];
     not_free:=not_free+tasks.task_v[nowindex]^.dedication;
     push_tset(tse,not_free,headA);
     for i:=nowindex+1 to n do nastepny1prosze(i,tse,not_free);
    end;
  end;
end;

{procedura sito wybiera z wszystkich mozliwych tylko "najgestsze" kombinacje,
 do ktorych juz nic nie mozna dodac, bo albo jest zbyt malo wolnych procesorow
 albo wszyskie zadania sa w tej kombinacji. n1,nk- ile zad 1- i k-procesrowych,
 krotnosc-zadan wieloprocesorowych,wolne-liczba maszyn w systemie}

procedure sito(n1,nk,krotnosc,wolne:integer);
var tse,not_free:fs;
    headB:wezptr;
    i,j:integer;
    ok:boolean;
begin
 headB:=nil;
 with tasks do while headA<>nil do
  begin
   pop_tset(tse,not_free,headA);
   not_free:=[];
   i:=1;
   ok:=true;
   while (i<n) and (ok) do
    begin
     if not(i in tse) then if not_free*task_v[i]^.dedication=[] then ok:=false;
     inc(i);
    end;
   if ok then push_tset(tse,not_free,headB)
  end;
 headA:=headB;
end;

procedure generate_FS;
var i:integer;
begin
 with tasks do
  begin
   headA:=nil;
   for i:=1 to n do nastepny1prosze(i,[],[]);
   (*generacja wszystkich zbiorow dopuszczalnych zadan*)
   (*if readkey='?' then stackstate(true,headA);*)
   (* sito(n1,nk,k,ma); {odchudzenie zbioru kombinacji}*)
   stackstate(false,headA);
  end;
end;










procedure mount(s_j:sequence_pointer;now:real);
{add to completion times tasks starting with s_j}
var i:integer;
begin
 for i:=1 to tasks.n do
 if ([i]*s_j^.feasible_set^.task<>[]) and (completion^[i]=0) then {start now this task}
 completion^[i]:=now+tasks.task_v[i]^.tasktime;
end;

procedure unmount(s_j:sequence_pointer;now:real);
{remove from completion times tasks starting with s_j}
var i:integer;
begin
 for i:=1 to tasks.n do
 if ([i]*s_j^.feasible_set^.task<>[]) and (completion^[i]-tasks.task_v[i]^.tasktime>=now) then
 completion^[i]:=0;
end;





function processing_time(s_j:sequence_pointer;now:real):real;
{returns processing time of (global) sequence+s_j that is the time till the earliest end of any task
 WARNING: assumed not maximal feasible sets are included}
var earliest_end:real;
    i:integer;
begin
 earliest_end:=MaxReal;
 mount(s_j,now);
 with tasks do for i:=1 to n do if completion^[i]>now then earliest_end:=minr(earliest_end,completion^[i]);
 processing_time:=earliest_end-now;
 unmount(s_j,now);
end;


procedure sort_FS;
type val_ptr=record
             val:real;
             ptr:wezptr;
            end;
    v_parrp=^v_parr;
    v_parr=array[1..MaxN] of val_ptr;

var a:v_parrp;
    tmp:wezptr;
    i,j:integer;
    seq:sequence_pointer;


procedure quicksort(a: v_parrp; Lo,Hi: integer);

procedure sort(l,r: integer);
var
  i,j: integer;
  x:real;
  y:val_ptr;
begin
  i:=l; j:=r; x:=(a^[(l+r) DIV 2].val);
  repeat
    while a^[i].val<x do i:=i+1;
    while x<a^[j].val do j:=j-1;
    if i<=j then
    begin
      y:=a^[i];
      a^[i]:=a^[j];
      a^[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

begin {sort_FS}
 tmp:=headA;
 if memP(sizeof(seq^)) then
  begin
   new(seq);
   Inc(memory,SizeOf(seq^));
  end;
 if memP(number_of_feasible_sets*(sizeof(wezptr)+sizeof(real)))
  then getmem(a,number_of_feasible_sets*(sizeof(wezptr)+sizeof(real)));
 for j:=1 to number_of_feasible_sets do       {Memorize values and associated pointers}
  begin
   a^[j].ptr:=tmp;
   seq^.feasible_set:=tmp;
   seq^.finish:=processing_time(seq,0);
   a^[j].val:=0;
   for i:=1 to comp.nr_comp_proc do
    begin
     if (tmp^.processors_used*[i]<>[]) then {a^[j].val:=max over machines of {PC's after tmp^ execution}
      begin
       if a^[j].val<PC_req^[i]-seq^.finish then a^[j].val:=PC_req^[i]-seq^.finish
      end
     else if a^[j].val<PC_req^[i] then a^[j].val:=PC_req^[i];
    end;
   tmp:=tmp^.next;
  end;
 quicksort(a,1,number_of_feasible_sets);
 headA:=a^[1].ptr;         {Create new order of records in the list}
 for j:=1 to number_of_feasible_sets-1 do a^[j].ptr^.next:=a^[j+1].ptr;
 a^[number_of_feasible_sets].ptr^.next:=nil;
 freemem(a,number_of_feasible_sets*(sizeof(wezptr)+sizeof(real)));
 dispose(seq);
 stackstate(false,headA)
end; { sort_FS}


function numberP(S:sequence_pointer):integer;
var i:integer;
begin
 i:=0;
 while S<>nil do
  begin
   inc(i);
   S:=S^.next;
  end;
 numberP:=i;
end;

procedure sort_list(var S:sequence_pointer);
type val_ptr=record
             val:real;
             ptr:sequence_pointer;
            end;
    v_pap=^v_pa;
    v_pa=array[1..MaxN] of val_ptr;

var a:v_pap;
    tmp:sequence_pointer;
    i,j:integer;


procedure quicksort(a: v_pap; Lo,Hi: integer);

procedure sort(l,r: integer);
var
  i,j: integer;
  x:real;
  y:val_ptr;
begin
  i:=l; j:=r; x:=(a^[(l+r) DIV 2].val);
  repeat
    while a^[i].val<x do i:=i+1;
    while x<a^[j].val do j:=j-1;
    if i<=j then
    begin
      y:=a^[i];
      a^[i]:=a^[j];
      a^[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

begin     {sort_list}
 tmp:=S;
 i:=numberP(S);
 if memP(i*(sizeof(sequence_pointer)+sizeof(real))) then getmem(a,i*(sizeof(sequence_pointer)+sizeof(real)));
 for j:=1 to i do       {Memorize values and associated pointers}
  begin
   a^[j].val:=tmp^.l;
   a^[j].ptr:=tmp;
   tmp:=tmp^.next;
  end;
 quicksort(a,1,i);
 S:=a^[1].ptr;         {Create new order of records in the list}
 for j:=1 to i-1 do a^[j].ptr^.next:=a^[j+1].ptr;
 a^[i].ptr^.next:=nil;
 freemem(a,i*(sizeof(sequence_pointer)+sizeof(real)));
end; {of sort_list}


procedure forget(var from:sequence_pointer);
var tmp:sequence_pointer;
begin
 while from<>nil do {release old version}
  begin
   tmp:=from;
   from:=from^.next;
   dispose(tmp);
  end;
 from:=nil;
end;


procedure store(seq,s_j:sequence_pointer;var Cmx:real);
var tmp,tmp1:sequence_pointer;
    tmpA:wezptr;
    tsk:fs;
    ey,ex:boolean;


 {The following procedure returns "true" if there is at least one task
 already started and to be continued in the following feasible sets,
 otherwise returns "false"}

function after_bestP:boolean;
var ex:boolean;
begin
 ex:=true;
 i:=1;
 while (i<=tasks.n) and ex do
  begin
   if completion^[i]>best^.finish then ex:=false;
   inc(i);
  end;
 after_bestP:=not(ex);
end;


begin
 forget(best);      {release old version}
 if memP(sizeof(best^)) then
  begin
   new(best);         {create new one with s_j heading}
   Inc(memory,SizeOf(best^));
  end;
 best^:=s_j^;
 tmp1:=best;
 while seq<>nil do
  begin
   if memp(sizeof(tmp^)) then
    begin
     new(tmp);
     Inc(memory,SizeOf(tmp^));
    end;
   tmp^:=seq^;
   tmp1^.next:=tmp;
   tmp1:=tmp;
   seq:=seq^.next;
  end;
 tmp1^.next:=nil;
 if s_j=nil then    {remove "empty" heading if entered with s_j=nil}
  begin
   tmp:=best;
   best:=best^.next;
  end

 {One can only enter this procedure with s_j=nil, or when s_j^.l=s_j^.u.
 Thus either there is nothing to append or
 processing time of the most loaded processor is equal to the serial execution time of
 remaining tasks (parts must be continued as in seq+s_j^)
   The rest of the procedure finds sequence of feasible sets
 a) finishing tasks started erlier
 b) containing only tasks not started yet}
 else
  begin
   mount(s_j,best^.start);
   tmp:=best;               {tmp will let us unmount at the end}
   while after_bestP do     {Finish what is started}
    begin
     tmpA:=headA;
     while (tmpA<>nil) do
      begin
       i:=1;
       ex:=true;
       while (i<=tasks.n) and ex do {feasible set tmpA^ contains all started tasks?}
        begin
         if (completion^[i]>0) then
          begin
           if ((completion^[i]<=best^.finish) and (tmpA^.task*[i]<>[]))
                    {has task completed earlier - ... off!}
           or ((completion^[i]>best^.finish) and (tmpA^.task*[i]=[]))
                    {does not have the task stretching through feasible set s_j - ... off!}
           then ex:=false;
          end
         else if (tmpA^.task*[i]<>[]) then ex:=false;  {has task not started yet. Finish what started first!}
         inc(i);
        end;
       if ex then
        begin
         if memp(sizeof(tmp1^)) then
          begin
           new(tmp1);
           Inc(memory,SizeOf(tmp1^));
          end;
         tmp1^.feasible_set:=tmpA;
         tmp1^.next:=best;
         tmp1^.start:=best^.finish;
         tmp1^.finish:=best^.finish+processing_time(tmp1,best^.finish);
         best:=tmp1;
        end;
       tmpA:=tmpA^.next;
      end;
    end;
   tmpA:=headA;       {add feasible sets containing only tasks not started yet}
   ex:=true;
   i:=1;
   while (i<=tasks.n) and ex do
    begin
     if completion^[i]=0 then ex:=false;
     inc(i);
    end;
   if not(ex) then
   while (tmpA<>nil) do
    begin
     i:=1;
     ex:=true;
     if cardinality(tmpA^.task)=1 then
     while (i<=tasks.n) and ex do
      begin
       if tmpA^.task=[i] then
       if (completion^[i]=0) then ex:=false;
                 {this feasible set only one task not started earlier - accept}
       inc(i);
      end;
     if not(ex) then
      begin
       if memp(sizeof(tmp1^)) then
        begin
         new(tmp1);
         Inc(memory,SizeOf(tmp1^));
        end;
       tmp1^.feasible_set:=tmpA;
       tmp1^.next:=best;
       tmp1^.start:=best^.finish;
       tmp1^.finish:=best^.finish+tasks.task_v[i-1]^.tasktime;
       mount(tmp1,best^.finish);
       best:=tmp1;
      end;
     tmpA:=tmpA^.next;
    end;
   tmp1:=best;
   while tmp1<>tmp do
    begin
     unmount(tmp1,tmp^.start);
     tmp1:=tmp1^.next;
    end;
   unmount(tmp1,tmp^.start);
  end;
 {wl;}
 if Cmx>best^.finish then
  Cmx:=best^.finish;
end; { store}

function immediately_after(s_j:sequence_pointer;start,stop:real):sequence_pointer;
{returns a list of feasible sets that:
a)have to be executed after sequence+s_j (if there are any)
  ie. feasible_sets with all tasks that started earlier are included in those feasible_sets
b)if all tasks from sequence+s_j finish at the end of finish+s_j then feasible
  sets of tasks not executed yet.}
var i:integer;
    ex:boolean;
    tmp:wezptr;
    res,post:sequence_pointer;
begin
 post:=nil;
 tmp:=headA;
 mount(s_j,start);
 while tmp<>nil do
  begin
   i:=1;
   ex:=true;
   while (i<=tasks.n) and ex do {feasible set tmp^ contains all started tasks?}
    begin
     if completion^[i]>0 then
     if ((completion^[i]<=stop) and (tmp^.task*[i]<>[])) {has task completed earlier}
     or ((completion^[i]>stop) and (tmp^.task*[i]=[]))   {does not have the task stretching through feasible set s_j}
      then ex:=false;
     inc(i);
    end;
   if ex then
    begin
     if memp(sizeof(res^)) then
      begin
       new(res);
       Inc(memory,SizeOf(res^));
     end;
     inc(number_of_possible_branches);
     res^.feasible_set:=tmp;
     res^.next:=post;
     post:=res;
    end;
   tmp:=tmp^.next;
  end;
 unmount(s_j,start);
 immediately_after:=post;
end;



procedure solve(var S:sequence_pointer;var lo,up,Cmx:real;Ca,Pt:real;PC_req:vector_ptr);
var s_j,tmp:sequence_pointer;
    max_PC:real;
    i,i1:integer;
    by,bx:byte;
begin
{ sequence_state('Wejscie do Solve');}
(* if (inf in ['y','Y']) then
  begin
   write('*');
   by:=whereY;
   bx:=whereX;
   Wopen(1,23,80,25,'#of search nodes, memavail, #of possible branches, #at level0',bx,by);
   write(Number_of_search_tree_nodes,'   ',memavail,'   ',number_of_possible_branches,'   ',number_of_branches_at_level0);
   clreol;
   window(1,11,80,22);
   gotoxy(bx,by);
  end;*)
 s_j:=S;
 if (S=nil) and (Ca<Cmx) then {finishing sequence}
  begin
   Cmx:=Ca;
   store(sequence,s_j,Ca) { store as the best sequence+s_j};
   dec(number_of_possible_branches,1);
  end
 else
  begin
   while s_j<>nil do {take acceptable successor from reservoire and evaluate}
    begin
     if memP(sizeof(real)*comp.nr_comp_proc) then getmem(s_j^.PC,sizeof(real)*comp.nr_comp_proc);
     for i:=1 to comp.nr_comp_proc do s_j^.PC^[i]:=PC_req^[i];    {Store ProcessingCapacities_required}
     s_j^.start:=Ca;
     s_j^.finish:=Ca+processing_time(s_j,Ca); {sequence as a global variable points to the last feasible set}
     s_j^.u:=s_j^.finish+Pt-cardinality(s_j^.feasible_set^.task)*(s_j^.finish-Ca);
     max_PC:=0;
     for i:=1 to comp.nr_comp_proc do
      begin
       if ([i]*s_j^.feasible_set^.processors_used<>[]) then s_j^.PC^[i]:=s_j^.PC^[i]-(s_j^.finish-s_j^.start);
       if max_PC<s_j^.PC^[i] then max_PC:=s_j^.PC^[i];
      end;
     s_j^.l:=s_j^.finish+max_PC;
     s_j^.that_follows:=immediately_after(s_j,Ca,s_j^.finish);
     if (s_j^.l=s_j^.u) and (Cmx>s_j^.l) then {finishing sequence}
      begin
       Cmx:=s_j^.u;
       store(sequence,s_j,Cmx);             { store as the best sequence+s_j}
      end;
     s_j:=s_j^.next;
     inc(number_of_search_tree_nodes);
    end;

   (*if (inf in ['y','Y']) then write('S');*)
   sort_list(S);

   s_j:=S;
   while s_j<>nil do  {for each s_j in S in order of increasing s_j^.l}
    begin
     tmp:=s_j^.next;
     if (s_j^.l<up) and (Cmx>s_j^.l) then {try only if possible improvement}
      begin
       if lo>s_j^.l then
        begin
         lo:=s_j^.l;
         up:=s_j^.u;
        end;
       s_j^.next:=sequence;
       sequence:=s_j;
       mount(s_j,Ca);    {add s_j to completion times and to beginning SEQUENCE}

{       sequence_state('Zstepowanie w Solve');}
       solve(s_j^.that_follows,lo,up,Cmx,s_j^.finish,Pt-cardinality(s_j^.feasible_set^.task)*(s_j^.finish-Ca),s_j^.PC);
{       sequence_state('Powrot rekursji do Solve');}
       unmount(s_j,Ca);  {remove s_j}
       sequence:=s_j^.next;
       s_j^.next:=tmp;
      end;
     dec(number_of_possible_branches,numberP(s_j^.that_follows));
     forget(s_j^.that_follows);  {free memory}
     freemem(s_j^.PC,sizeof(real)*comp.nr_comp_proc);
     s_j:=tmp;
    end;
  end;
{ sequence_state(' Wychodzenie z Solve');}
(* if (inf in ['y','Y']) then
  begin
   write('+');
   by:=whereY;
   bx:=whereX;
   Wopen(1,23,80,25,'#of search nodes, memavail, #of possible branches, #at level0',bx,by);
   write(Number_of_search_tree_nodes,'   ',memavail,'   ',number_of_possible_branches,'   ',number_of_branches_at_level0);
   clreol;
   window(1,11,80,22);
   gotoxy(bx,by);
  end;*)
end;  { Solve }

procedure Hrandom;
{This procedure schedules tasks on by one mowing them in one by one to the left}
var curr_tasks:fs;
    now:real;
    i:integer;
    tmp:sequence_pointer;

procedure remaining_tasks_and_processors(var task,processors_used:fs;now:real);
var i:integer;
begin
 with tasks do
  begin
   task:=[];
   processors_used:=[];
   for i:=1 to n do if completion^[i]>now then
    begin
     task:=task+[i];
     processors_used:=processors_used+task_v[i]^.dedication;
    end;
  end;
end;




procedure Join(var seq:sequence_pointer;now:real;i:integer);
var tmp:sequence_pointer;
begin
 with tasks do
 if i<=n then
  begin
   seq^.feasible_set^.task:=seq^.feasible_set^.task+[i];
   seq^.feasible_set^.processors_used:=seq^.feasible_set^.processors_used+task_v[i]^.dedication;
   while (i+1<=n) and (task_v[i+1]^.dedication*seq^.feasible_set^.processors_used=[]) do
    begin
     inc(i);
     seq^.feasible_set^.task:=seq^.feasible_set^.task+[i];
     seq^.feasible_set^.processors_used:=seq^.feasible_set^.processors_used+task_v[i]^.dedication;
    end;
   if (i+1<=n) then {that means not all tasks are added to the current feasible set}
   while (seq^.feasible_set^.processors_used*task_v[i+1]^.dedication<>[]) and
         (seq^.feasible_set^.processors_used<>[]) do
    begin
     seq^.finish:=now+processing_time(seq,now);
     mount(seq,now);
     now:=seq^.finish;
     tmp:=seq;
     new(seq);
     Inc(memory,SizeOf(seq^));
     seq^.start:=now;
     seq^.next:=tmp;
     new(seq^.feasible_set);
     Inc(memory,SizeOf(seq^.feasible_set^));
     remaining_tasks_and_processors(seq^.feasible_set^.task,seq^.feasible_set^.processors_used,now);
    end;
   if (i+1<=n) then join(seq,seq^.start,i+1)
   else {i+1>n all task added - create sequence of feasible sets of tasks' endings}
    begin
     while (seq^.feasible_set^.processors_used<>[]) do
      begin
       seq^.finish:=now+processing_time(seq,now);
       mount(seq,now);
       now:=seq^.finish;
       tmp:=seq;
       new(seq);
       Inc(memory,SizeOf(seq^));
       seq^.start:=now;
       seq^.next:=tmp;
       new(seq^.feasible_set);
       Inc(memory,SizeOf(seq^.feasible_set^));
       remaining_tasks_and_processors(seq^.feasible_set^.task,seq^.feasible_set^.processors_used,now);
      end;
     tmp:=seq^.next;
     dispose(seq); {because seq is empty}
     seq:=tmp;
    end;
  end;
end;


begin {Hrandom}
 getmem(completion,tasks.n*sizeof(real));
 for i:=1 to tasks.n do completion^[i]:=0;
 i:=1;
 new(sequence);
 Inc(memory,SizeOf(sequence^));
 sequence^.next:=nil;
 new(sequence^.feasible_set);
 Inc(memory,SizeOf(sequence^.feasible_set^));
 sequence^.feasible_set^.task:=[];
 sequence^.feasible_set^.processors_used:=[];
 Join(sequence,0,1);
 writeln('RANDOM HEUR Cmax=',sequence^.finish:8:3);
 best:=sequence;
 for i:=1 to tasks.n do writeln('Task ',i,' completion ',completion^[i]:6:2);
 while sequence<>nil do
  begin
   tmp:=sequence;
   sequence:=sequence^.next;
   dispose(tmp);
  end;

end; {Hrandom}



begin  {of Schedulding}
(* Hrandom;*)

 memory:=0;
 with tasks do
 with comp do
 with sched do
	begin
	{ if is_act_sch then release(heapptr);
	 mark(heapptr);}
   initsched(sched,1,nr_comp_proc);
	 gettime(hr,mn,sc,sc100);
  (* if (inf in ['y','Y']) then wopen(1,10,80,22,'Full info',bx,by);*)

   number_of_search_tree_nodes:=0;
   number_of_possible_branches:=0;
   generate_FS;
   number_of_branches_at_level0:=number_of_feasible_sets;
   if memP(n*sizeof(real)) then getmem(completion,n*sizeof(real));
   for i:=1 to n do completion^[i]:=0;
   if memP(nr_comp_proc*sizeof(real)) then getmem(PC_req,nr_comp_proc*sizeof(real));
   upper:=MaxReal;
   lower:=MaxReal;
   Cmax:=MaxReal;
   sequence:=nil;
   best:=nil;
   Pt:=0;
   for i:=1 to n do Pt:=Pt+task_v[i]^.tasktime;
   max_PC:=0;
   for i:=1 to nr_comp_proc do  {Compute PC's}
    begin
     PC_req^[i]:=0;
     for i1:=1 to n do if task_v[i1]^.dedication*[i]<>[] then PC_req^[i]:=PC_req^[i]+task_v[i1]^.tasktime;
    end;
   sort_FS;               {Sort Feasible Sets by lower estimate}
   s_j:=headA;
   if memP(sizeof(sequence^)) then
    begin
     new(sequence);
     Inc(memory,SizeOf(sequence^));
    end;
   tmp_r:=sequence;
   while s_j<>nil do   {for all s_j in S=headA do}
    begin
     for i:=1 to n do completion^[i]:=0;
     sequence^.next:=nil;      {plant new sequence}
     sequence^.start:=0;       {remember where the sequence ends}
     sequence^.feasible_set:=s_j;
     sequence^.finish:=processing_time(sequence,0);  {S=sequence passed as a global variable}
     sequence^.that_follows:=immediately_after(sequence,0,sequence^.finish);
     max_PC:=0;
     for i:=1 to comp.nr_comp_proc do
      begin
       if (sequence^.feasible_set^.processors_used*[i]<>[]) then PC_req^[i]:=PC_req^[i]-sequence^.finish;
       if max_PC<PC_req^[i] then max_PC:=PC_req^[i];
      end;
     sequence^.l:=sequence^.finish+max_PC;
     sequence^.u:=sequence^.finish+Pt-cardinality(s_j^.task)*sequence^.finish;
     mount(sequence,0);
{     sequence_state('Start new sequence - root');}
     solve(sequence^.that_follows,lower,upper,Cmax,sequence^.finish,
           Pt-cardinality(s_j^.task)*sequence^.finish,PC_req);

     { unmounting is performed in the beginning with for i:= ... completion^[i]:=0}
{     sequence_state('After recurse - root - plant next');}
{     Memory:=memory-memavail;}
     for i:=1 to comp.nr_comp_proc do
      if (sequence^.feasible_set^.processors_used*[i]<>[]) then PC_req^[i]:=PC_req^[i]+sequence^.finish;
     dec(number_of_possible_branches,numberP(sequence^.that_follows));
     dec(number_of_branches_at_level0);
     forget(sequence^.that_follows);
     s_j:=s_j^.next;
    end;
   dispose(sequence);          {release old sequence}
   freemem(PC_req,nr_comp_proc*sizeof(real));
   freemem(completion,n*sizeof(real));
   sequence:=best;
{   sequence_state('Final');}
   sched.c:=best^.finish;      {copy results to sched structure}
   sched.m:=comp.nr_comp_proc;
   while sequence<>nil do
    begin                          {is processor i occupied?}
     for i:=1 to sched.m do if sequence^.feasible_set^.processors_used*[i]<>[] then with sched.schedul[i]^ do
      begin
       if end_time<sequence^.finish then end_time:=sequence^.finish; {If it is, then by which task?}
       ex:=true;
       i1:=1;
       while (i1<=tasks.n) and ex do
        begin
         if (tasks.task_v[i1]^.dedication*[i]<>[]) and ([i1]*sequence^.feasible_set^.task<>[]) then ex:=false;
         if ex then inc(i1);
        end;                        {It is task # i1}
       if (nrts>0) and (a[nrts].tnr=i1) then
        begin
         a[nrts].begint:=sequence^.start; {lengthen interval, no new tasks}
         a[nrts].usestime:=a[nrts].endt-a[nrts].begint;
        end
       else
        begin       {new task}
         inc(nrts);
         a[nrts].begint:=sequence^.start;
         a[nrts].endt:=sequence^.finish;
         a[nrts].usestime:=a[nrts].endt-a[nrts].begint;
         a[nrts].tnr:=i1;
        end;
      end;
     sequence:=sequence^.next;
    end;
   while headA<>nil do pop_tset(pustak,pustak,headA);
   forget(best);
   workt:=getsec(hr,mn,sc,sc100);
  end;

 end;   {of Schedulding}

end.

