

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Gantt                                                       *}
{*                                                                           *}
{*  In this unit Gantt's diagram procedure is given.                         *}
{*                                                                           *}
{*****************************************************************************}
{PCoption}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}
{$R GANTT.RES}
{$R Print.RES}
unit Gantt1;

interface

uses Strings,ODialogs,Objects,OWindows,WinTypes, WinProcs,OStdWnds,win31,
     OPrinter,
     Deklar,FileGen,ConsObj,Result;

const

 Colors: array[0..14] of TColorRef =
    ($C0C0C0,$000080,$008080,$008000,$808000,$800000,$800080,
     $808080,$000000,$0000FF,$00FFFF,$00FF00,$FFFF00,$FF0000,
     $FF00FF);

 id_GPrint = 222;
 id_Zoom   = 333;
 id_Close  = 1;

type

  RTask = record
            x1,y1: Integer;
            x2,y2: Integer;
            num  : Integer;
            proc : Integer;
            ind  : Integer
          end;

  Range = (Zoom,Piece);

  PGDialog = ^TGDialog;
  TGDialog = object(TDialog)
    constructor Init(AParent: PWindowsObject;ATitle: PChar);
    procedure SetUpWindow;virtual;
    procedure FillIn(Id:Integer;Text:PChar);
    destructor done;virtual;
  end;

  PGantt = ^TGantt;
  TGantt = object(TWindow)
   ATask: array[1..600] of RTask;
   Printer: PPrinter;
   Size: Integer;
   D: PGDialog;
   Opened:Boolean;
   constructor Init(AParent: PWindowsObject;ATitle: PChar);
   procedure WMLButtonDown(var Msg: TMessage);virtual wm_First + wm_LButtonDown;
   procedure ButtonClose(var Msg: TMessage);virtual id_First + id_Close;
   procedure ButtonZoom(var Msg: TMessage);virtual id_First + id_Zoom;
   procedure ButtonPrint(var Msg: TMessage);virtual id_First + id_GPrint;
   procedure SetRange;
   procedure Paint(PaintDC: HDC;var PaintInfo: TPaintStruct); virtual;
   procedure CMPrint;virtual;
   procedure CMSetup;virtual;
   procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
  end;

var

 MaxX,MaxY,MinY,MinX,Mx,My: Integer;
 Rng: Range;
 Button: Boolean;


implementation

procedure Assign(PaintDC: HDC);
 var
  F,OldF: HFont;
  Font:   TLogFont;
  s:      PChar;
 begin
  F:=CreateFont(12,6,0,0,FW_Medium,1,0,0,0,out_default_precis,
              clip_default_precis,default_quality,FF_Swiss,nil);
  OldF:= SelectObject(PaintDC,F);
  SelectObject(PaintDC,F);
  s:='Processor number';
  TextOut(PaintDC,MinX+5,MinY-18,s,StrLen(s));
  s:='Time';
  TextOut(PaintDC,MaxX+2,MaxY-15,s,StrLen(s));
  SelectObject(PaintDC,OldF);
  DeleteObject(F);
 end;

constructor TGDialog.Init;
begin
 inherited Init(AParent,Atitle);
 PGantt(Parent)^.Opened:=True;
end;

procedure TGDialog.SetUpWindow;
begin
 inherited SetUpWindow;
 SetWindowPos(HWindow,HWND_TOP,PosX,PosY,0,0,SWP_NOSIZE);
end;

procedure TGDialog.FillIn(Id:Integer;Text:Pchar);
begin
 SetDlgItemText(HWindow,Id,Text);
end;

destructor TGDialog.Done;
var
R:Trect;
begin
 GetWindowRect(HWindow,R);
 PosX:=R.Left;
 PosY:=R.Top;
 TDialog.done;
 PGantt(Parent)^.Opened:=false
end;

procedure TGantt.WMSize(var Msg: TMessage);
 begin
  TWindow.WMSize(Msg);
 end;


constructor TGantt.Init(AParent: PWindowsObject; ATitle: PChar);
 var
  TempBtn,BtnZoom: PButton;
 begin
  TWindow.Init(AParent, ATitle);
  Attr.X := 10;
  Attr.Y := 10;
  Attr.W := 580;
  Attr.H := 400;
  PosX:=40;
  PosY:=200;
  Attr.Style := Attr.Style or ws_overlapped or ws_thickframe or ws_caption or ws_sysmenu or  ws_MinimizeBox or ws_SizeBox or
                  ws_MaximizeBox  or ws_Visible or ws_VScroll or ws_HScroll;
  BtnZoom := New(PButton, Init(@Self,333, 'Zoom', 5, 20, 40, 30,False));
  TempBtn := New(PButton, Init(@Self,222, 'Print', 5, 70, 40, 30, False));
  TempBtn := New(PButton, Init(@Self,1, 'Close',5, 120, 40, 30, False));
  Scroller := New(PScroller, Init(@Self,20,20,100,100));
  Printer:=New(PPrinter,Init);
  Button:=False;
  Rng:=Piece;
  SetRange;
  Opened:=False;
  if Rng=Zoom then BtnZoom^.Attr.Style:= BtnZoom^.Attr.Style{ or ws_Disabled};
  DisableAutoCreate;

end;

procedure TGantt.CMPrint;
 var
  P: PWindowPrintout;
 begin
  P := New(PWindowPrintout, Init('gantt', @Self));
  P^.Scale:=True;
  Printer^.Print(@Self, P);
  Dispose(P, Done);
end;

procedure TGantt.CMSetup;
begin
  Printer^.Setup(@Self);
end;



 procedure TGantt.ButtonClose(var Msg: TMessage);
  begin
   CloseWindow;
  end;

 procedure TGantt.ButtonPrint(var Msg: TMessage);
  begin
   CMSetup;
   CMPrint;
  end;


 procedure TGantt.ButtonZoom(var Msg: TMessage);
 var
  G:PGantt;
  OldRng: Range;
 begin
   OldRng:=Rng;
   TGantt.Done;
   G := PGantt(Application^.MakeWindow(New(PGantt, Init(@Self,'Gantt'))));
   Button:=True;
   Rng:=OldRng;
   if Rng=Zoom then Rng:= Piece else Rng:= Zoom;
  end;


procedure TGantt.WMLButtonDown(var Msg: TMessage);
 var
  PaintDC: HDC;
  Clip: HRgn;
  E1,E2,E3,E4,E5: PEdit;
  Ch: Wrd1;
  Ch1: Strg1;
  S: string[9];
  i,k,TheMoveX,TheMoveY,Return: Integer;
  R: TRect;

procedure Blank(var s: String);
 begin
   while ((s[1]=' ') or (s[1]=chr(9))) and (s<>'') do
      delete(s,1,1);
 end;

procedure TheInt(var Ch: Wrd1);
 var
  i: Integer;
  Ch1: Wrd1;
 begin
   i:=0;
   StrCopy(Ch1,#13);
   while (Ch[i]<>'.') do
    begin
     Ch1[i]:=Ch[i];
     Inc(i)
    end;
   StrCopy(Ch,Ch1);
   Ch[i]:=#0;
 end;


procedure AInsert(num: Real; var Ch: Wrd1;X,Y:Integer);
 var
  s: String;
 begin
  StrCopy(Ch,'');
  Str(num:X:Y,s);
  Blank(s);
  StrPCopy(Ch,s);
 end;

procedure FillEdit(num: Integer);
var
 s: String;
 P:Wrd1;

begin
  with tasks do
    with task_v[num]^ do
     begin
      AInsert(tasktime,Ch,10,4);
      D^.FillIn(108,Ch);
      AInsert(rdytime,Ch,10,4);
      D^.FillIn(109,Ch);
      AInsert(ddate,Ch,10,4);
      D^.FillIn(614,Ch);
      AInsert(prcsnum,Ch,10,4);
      D^.FillIn(615,Ch);
      TheSet(s,dedication);
      StrPCopy(P,S);
      D^.FillIn(616,P);
   end;
end;



begin
  TheMoveX:=Scroller^.XUnit*GetScrollPos(HWindow,sb_horz);
  TheMoveY:=Scroller^.YUnit*GetScrollPos(HWindow,sb_vert);

  for i:=1 to Size do
   if (Msg.LParamLo+TheMoveX < ATask[i].X2)  and (Msg.LParamLo+TheMoveX > ATask[i].X1) and
       (Msg.LParamHi+TheMoveY < ATask[i].Y2) and (Msg.LParamHi+TheMoveY < ATask[i].Y2)then
    begin
     If opened then d^.destroy;
     D:=New(PGDialog,Init(@Self,'Gantt'));
     D^.create;

     with sched.schedul[ATask[i].proc]^.a[ATask[i].ind] do
      begin
       AInsert(begint,Ch,10,4);
       D^.FillIn(105,Ch);
       AInsert(begint+usestime,Ch,10,4);
       D^.FillIn(106,Ch);
       AInsert(ATask[i].proc,Ch,10,4);
       TheInt(Ch);
       D^.FillIn(107,Ch);
       FillEdit(ATask[i].num);
       AInsert(ATask[i].num,Ch,10,4);
       TheInt(Ch);
       D^.FillIn(110,Ch);
      end;
     if Return <> idCancel then  i:=Size;
    end;
end;

procedure TGantt.SetRange;
 var
  R: TRect;
  rangeX,rangeY: Integer;
  ZoomX,ZoomY: Boolean;

begin
 GetClientRect(HWindow,R);
 MinX:=R.Left+100;
 MinY:=R.Top+20;
 ZoomX:=False;
 ZoomY:=False;

 rangeX:=Round(sched.c);
 if (0<=rangeX) and (rangeX<=40) then
  begin
   MaxX:=R.Right-30;
   ZoomX:=True
  end;
 if (40<=rangeX) and (rangeX<80)  then MaxX:=Round(3/2*R.Right);
 if rangeX>=80 then MaxX:=2*R.Right;

 rangeY:=comp.nr_comp_proc;
 if (1<=rangeY) and (rangeY<=5) then
  begin
   MaxY:=Trunc(R.Bottom/2)+20;
   ZoomY:=True
  end;
 if (6<=rangeY) and (rangeY<=10) then MaxY:=R.Bottom-30;
 if (11<=rangeY) and (rangeY<32) then MaxY:=2*R.Bottom+20;
 if (33<=rangeY) and (rangeY<64) then MaxY:=3*R.Bottom+20;
 if (65<=rangeY) then MaxY:=4*R.Bottom+20;

 if (ZoomX and ZoomY)  then Rng:=Zoom;
end;

procedure TGantt.Paint(PaintDC: HDC;var PaintInfo: TPaintStruct);

var
  Pen,OldPen: HPen;
  Brush,OldBrush: HBrush;
  F,OldF: HFont;
  R: TRect;
  i,j,k,X,Y,MinY1,rangeX,rangeY,TheCoord: Integer;
  Min12: Real;
  Indeks: TColorRef;
  ColorTask: array[0..MaxN] of Integer;
  z,Ch: Wrd1;
  ZoomX,ZoomY: Boolean;

procedure TaskCol(size: Integer);
 var
  i,k: Integer;
 begin
  k:=0;
  for i:=1 to size do
   begin
    ColorTask[i]:=k mod 14;
    inc(k);
   end
 end;


function coord(x: Real): Real;
 begin
  coord:=(MinX+6)+ Mx*x;
 end;

 procedure Scale(i:Integer);
  var
   s: String[5];
  begin
   Str(i,s);
   StrPCopy(Ch,s);
  end;


procedure Znum(i: Integer);
 var
  s: String[5];
  z1: Wrd1;
 begin
  Str(i,s);
  StrPCopy(z1,s);
  StrCopy(z,'z');
  StrCat(z,z1);
 end;

begin
 SetRange;
 if Button and (Rng=Zoom) then
  begin
   GetClientRect(HWindow,R);
   MaxX:=R.Right-30;
   MaxY:=R.Bottom-30;
  end;
 My:=Trunc((MaxY-MinY) / comp.nr_comp_proc);
 Mx:=Trunc((MaxX-MinX)/sched.c);

 TaskCol(tasks.n);
 k:=1;
{ F:=CreateFont(Round(My/3),Round(My/4),0,0,FW_Bold,1,0,0,0,out_default_precis,
        clip_default_precis,default_quality,FF_DontCare,nil);}
 F:=CreateFont(15,7,0,0,FW_Bold,1,0,0,0,Out_TT_Precis,
        clip_tt_always,proof_quality,Variable_Pitch Or FF_Roman,nil); {Constant High&Width}
 OldF:= SelectObject(PaintDC,F);
 SelectObject(PaintDC,F);

 X:=1;
 for i:=1 to comp.nr_comp_proc do
  begin
   with sched.schedul[i]^ do
    for j:=1 to nrts do with a[j] do
     begin
      Indeks:=Colors[ColorTask[tnr]];
      Brush:=CreateHatchBrush(HS_BDiagonal,Indeks);
      Pen:=CreatePen(ps_solid,1,indeks);
      OldBrush:=SelectObject(PaintDC,Brush);
      OldPen:=SelectObject(PaintDC,Pen);
      SelectObject(PaintDC,Pen);
      SelectObject(PaintDC,Brush);

      Rectangle(PaintDC,Round(coord(begint))+1,MinY+(i-1)*My,Round(coord(begint+usestime)),MinY+i*My-2);
{      SetTextColor(PaintDC,Indeks);}
      SetTextColor(PaintDC,0);       {Black task numbers}
      Znum(tnr);
      TheCoord:=Round(coord(begint+usestime)-coord(begint));
      if TheCoord>50 then
       TextOut(PaintDC,Round(coord(begint))+ Round((coord(begint+usestime)-coord(begint))/4),MinY+i*My-2-Trunc(My/2),
               z,StrLen(z));
      if (TheCoord<40) and (TheCoord>=34)then
       TextOut(PaintDC,Round(coord(begint)+5),MinY+i*My-2-Trunc(My/2),
               z,StrLen(z));

      ATask[k].x1:= Round(coord(begint));
      ATask[k].y1:= MinY+(i-1);
      ATask[k].x2:= Round(coord(begint+usestime));
      ATask[k].y2:= MinY+i*My-2;
      ATask[k].num:= tnr;
      ATask[k].ind:= j;
      ATask[k].proc:=i;
      Inc(k);
      SelectObject(PaintDC,OldBrush);
      SelectObject(PaintDC,OldPen);
      DeleteObject(Pen);
      DeleteObject(Brush);
      if coord(begint+usestime)>X then
       X:=Round(coord(begint+usestime));
     end;
   Inc(MinY1,Round(My));
  end;

  Size:=k;
  SelectObject(PaintDC,OldF);
  DeleteObject(F);

  Y:=MinY+i*My+4;
  Pen:=CreatePen(ps_solid,1,0);
  OldPen:=SelectObject(PaintDC,Pen);
  SelectObject(PaintDC,Pen);
  SetTextColor(PaintDC,0);
  F:=CreateFont(12,6,0,0,FW_Normal,1,0,0,0,out_default_precis,
              clip_default_precis,default_quality,FF_DontCare,nil);
  OldF:= SelectObject(PaintDC,F);
  SelectObject(PaintDC,F);

  MoveTo(PaintDC,MinX,MinY);
  LineTo(PaintDC,MinX,Y);
  LineTo(PaintDC,X+10,Y);
  MoveTo(PaintDC,MinX+4,Y);

  k:=0;
  j:=0;
  for i:=MinX+4 to X do
   begin
    if Mx<=12 then
     begin
      if (j mod 5)=0 then
       begin
        if i=MinX+4 then LineTo(PaintDC,i,Y+10) else
        LineTo(PaintDC,i-1,Y+10);
        Scale(k);
        TextOut(PaintDC,i,Y+20,Ch,StrLen(Ch));
       end
      end
     else
      begin
       if i=MinX+4 then LineTo(PaintDC,i,Y+10) else
       LineTo(PaintDC,i-1,Y+10);
       Scale(k);
       TextOut(PaintDC,i,Y+20,Ch,StrLen(Ch));
      end;
     Inc(i,Mx);
     Inc(k);
     Inc(j);
     MoveTo(PaintDC,i,Y);
     if i>X then i:=X;
    end;
  MoveTo(PaintDC,MinX,MinY);

  k:=1;
  for i:=MinY to comp.nr_comp_proc*My do
   begin
    if i=MinY then LineTo(PaintDC,MinX-10,i) else
    LineTo(PaintDC,MinX-10,i-1);
    Scale(k);
    TextOut(PaintDC,MinX-20,i-1,Ch,StrLen(Ch));
    Inc(i,My-1);
    Inc(k);
    MoveTo(PaintDC,MinX,i);
    if i> comp.nr_comp_proc*My  then i:=comp.nr_comp_proc*My;
   end;

 SelectObject(PaintDC,OldPen);
 DeleteObject(Pen);
 SelectObject(PaintDC,OldF);
 DeleteObject(F);

 Assign(PaintDC);
 ReleaseDC(HWindow,PaintDC);
end;

end.