{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Horn                                                           *}
{*                                                                           *}
{*  This unit contains procedure implementing Horn's                         *}
{*  scheduling algorithm.                                                    *}
{*                                                                           *}
{*****************************************************************************}

unit Horn;

{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses WinProcs,WinDos,Deklar,Tools,ToolHelp;

procedure HornA(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real; kp:ig);
{ Parametrs given:
     task - tasks set,
     comp - processor set,
     kp   - number of processors executing widest multiprocessor task,
  Parametrs returned:
     sched - schedule description,
     workt - how long schedule was computed}

implementation

procedure HornA(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real;kp:ig);
var
	Lm:real;
        Tsk:Task_rec;
        Com:Comp_rec;
        CountE:Integer;
        E:array [1..MaxM] of real;
        EndTime:array[1..MaxM] of Real;
	hr,mn,sc,sc100:word;
	i,j,k,np,nt:ig;
	tt: real;
	ch:char;
	equal,low,great:boolean;



function FindLmax(T:Task_rec;C:Comp_rec):Real;
{this procedure finds the maximum lateness}
var
 i:Integer;
 L1,L2,f:Real;

Function check(DueD:Real):Boolean;
var
j:Integer;
begin
  Check:=True;
  For j:=1 to CountE do
  if E[j]=DueD then Check:=False;
end;

Function FindRij(i,j:Integer):Real;
Var
Rij:real;
begin
 With T.task_v[i]^ do
 begin
  Rij:=tasktime-(ddate-E[j]);
  If Rij<0 then Rij:=0;
  If Rij>tasktime then Rij:=tasktime;
 end;
 FindRij:=Rij;
end;

procedure SortE;
var
 i,j:integer;
 temp:Real;
begin
 for i:=2 to CountE do
  for j:=CountE downto i do
    if E[j-1]>E[j] then
    begin
     temp:=E[j-1];
     E[j-1]:=E[j];
     E[j]:=temp;
    end;
end;


Function FindNj(j:Integer):Real;
var
 k:Integer;
 Nj:Real;
begin
  Nj:=0;
  For k:=1 to T.N do Nj:=Nj+FindRij(k,j);
  FindNj:=Nj;
end;

begin
  CountE:=0;
  L1:=0;
  L2:=0;
  For i:=1 to T.n do
   with T.task_v[i]^ do
   begin
    if i=1 then L1:=tasktime-ddate else
    if tasktime-ddate>=L1 then L1:= tasktime-ddate;
   end;
  For i:=1 to T.n do
   if (CountE=0)or(check(T.task_v[i]^.ddate)) then
   begin
    inc(CountE);
    E[CountE]:=T.task_v[i]^.ddate;
   end;
  SortE;
  For i:=1 to CountE do
  if i=1 then L2:=FindNj(i)/C.nr_comp_proc-E[i] else
  if FindNj(i)/C.nr_comp_proc-E[i]>L2 then
     L2:=FindNj(i)/C.nr_comp_proc-E[i];
  if L1>L2 then F:=L1 else F:=L2;
  FindLmax:=F;
end;

procedure InitDuplik(var T:task_rec;var C:comp_rec);
var
i:Integer;
begin
 For i:=1 to Comp.nr_comp_proc do
 begin
  new(C.comp_pr[i]);
  C.comp_pr[i]^:=Comp.Comp_pr[i]^;
 end;
 C.nr_comp_proc:=Comp.nr_comp_proc;
 For i:=1 to tasks.n do
 begin
  new(T.task_v[i]);
  T.task_v[i]^:=tasks.task_v[i]^;
 end;
 T.n:=tasks.n;
 T.nr_k:=tasks.nr_k;
end;

procedure SortTask(var t:task_rec);
var
 i,j:integer;
 p:task_ptr;
begin
  with t do
  begin
   for i:=2 to n do
    for j:=n downto i do
    if task_v[j-1]^.ddate>task_v[j]^.ddate then
    begin
     p:=task_v[j-1];
     task_v[j-1]:=task_v[j];
     task_v[j]:=p;
    end;
  end;
end;


procedure AssTask(task_nr:Integer;Due:Real);
var
 TimeNotUsed:Real;
 ProcNr:Integer;
 TDue,temp:Real;
begin
 ProcNr:=1;
 TimeNotUsed:=tsk.task_v[task_nr]^.TaskTime;
 TDue:=Due;
 with tsk.task_v[task_nr]^ do
 repeat
  with sched.schedul[ProcNr]^ do
  if TDue-endtime[ProcNr]>0 then
  begin
  If TDue-EndTime[ProcNr]>=TimeNotUsed then
  begin
   nrts:=nrts+1;
   a[nrts].tnr:=nr;
   a[nrts].begint:=EndTime[ProcNr];
   a[nrts].usestime:=TimeNotUsed;
   a[nrts].endt:=EndTime[ProcNr]+TimeNotUsed;
   EndTime[ProcNr]:=EndTime[ProcNr]+TimeNotUsed;
   TimeNotUsed:=0;
  end else
  begin
   nrts:=nrts+1;
   a[nrts].tnr:=nr;
   a[nrts].begint:=EndTime[ProcNr];
   a[nrts].usestime:=TDue-EndTime[ProcNr];
   a[nrts].endt:=TDue;
   TimeNotUsed:=TimeNotUsed-(TDue-EndTime[ProcNr]);
   temp:=EndTime[ProcNr];
   EndTime[ProcNr]:=TDue;
   TDue:=temp;
   ProcNr:=ProcNr+1;
  end;
  end else ProcNr:=ProcNr+1;
 until TimeNotUsed=0
end;

begin
 initsched(sched,1,comp.nr_comp_proc);
 InitDuplik(Tsk,Com);
 SortTask(tsk);
 with tsk do
 with com do
 with sched do
 begin
  for i:=1 to nr_comp_proc do
   begin
    sched.schedul[i]^.pr_speed:=comp_pr[i]^.comp_a[1].Comp_speed;
    EndTime[i]:=0;
   end;
  gettime(hr,mn,sc,sc100);
  Lm:=FindLmax(tasks,comp);
  for i:=1 to CountE do E[i]:=E[i]+Lm;
  For i:=1 to countE do
  begin
   for j:=1 to N do
   if task_v[j]^.ddate=E[i]-Lm then AssTask(j,E[i]);
  end;
  C:=0;
  for i:=1 to nr_comp_proc do if C<EndTime[i] then c:=EndTime[i];
  Lmax:=Lm;
  workt:=getsec(hr,mn,sc,sc100);
  is_act_sch:=true;
  memory:=0;
  For i:=1 to n do
  Dispose(tsk.task_v[i]);
  For i:=1 to nr_comp_proc do
  Dispose(com.comp_pr[i]);
 end;
end;
end.