{*****************************************************************************}
{*                                                                           *}
{*  Program : Symulato                                                       *}
{*  Unit    : Kproc                                                          *}
{*                                                                           *}
{*  An Algorithm implementing K-processor tasks preemptive scheduling on     *}
{*  uniform processors for C_max criterion.                                  *}
{*                                                                           *}
{*****************************************************************************}

{$I PCoption}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

unit kproc;

interface

uses WinDos,Deklar,Tools;

procedure Kprocs(var tasks:task_rec;var comp:comp_rec;var sched:schedul_rst;var workt:real;kp:ig);
{ Parametrs given:
     task - tasks set
     comp - processor set
     kp   - number of processors per mulitprocessor task
  Parametrs returned:
     sched - schedule description
     workt - how long schedule was computed}

implementation

procedure Kprocs(var tasks:task_rec;var comp:comp_rec;var sched:schedul_rst;var workt:real;kp:ig);
const maxdelt=30;
type nrdp_arr=array[1..MaxM]of ig;
     dp_arr=array[1..MaxM]of real;
var i,j,k:ig;
    comp_duo:comp_procs;
    duo:ig;
    t_task,k_task:task_arr;
    nr_t,nr_kp,x,nrpd:ig;
    Cmax,c1,c2,t_dp:real;
    a_cmax:array[1..maxdelt]of real;
    t_ra:task_rec1;
    nr_cmax:ig;
    hr,mn,sc,sc100:word;
    tab_nrdp:nrdp_arr;
    tab_dp:dp_arr;
    f:text;
    tmp_proc:comp_proc;
    tmp_task:task_rec0;

procedure setrst(var sched:schedul_rst;var comp:comp_rec);
var i:ig;
begin
 with sched do
  for i:=1 to m do
   begin
    new(schedul[i]);
    with comp.comp_pr[i]^ do
    with schedul[proc_nr]^ do
     begin
      end_time:=0;
      nrts:=0;
      pr_speed:=speed;
     end;
    c:=0;
  end;
end;

procedure make_k_t_task(var tasks:task_rec;var nr_kp:ig;var k_task:task_arr;
                            var nr_t:ig;var t_task:task_arr);
var i:ig;
begin
 nr_kp:=0;
 nr_t:=0;
 with tasks do for i:=1 to n do
 if task_v[i]^.prcsnum>1 then
  begin
   nr_kp:=nr_kp+1;
   new(k_task[nr_kp]);
   Inc(memory,SizeOf(task_rec0)+SizeOf(k_task[nr_kp]));
   k_task[nr_kp]^:=task_v[i]^;
  end
 else
  begin
   nr_t:=nr_t+1;
   new(t_task[nr_t]);
   Inc(memory,SizeOf(task_rec0)+SizeOf(t_task[nr_t]));
   t_task[nr_t]^:=task_v[i]^;
  end
end;

procedure sort_by_speed(n:ig;var comp_p:comp_procs);
var i,j:ig;
    tvar:comp_proc;
begin
 for i:=1 to n-1 do
 for j:=i+1 to n do
 if comp_p[i]^.speed<comp_p[j]^.speed then
  begin
   tvar:=comp_p[i]^;
   comp_p[i]^:=comp_p[j]^;
   comp_p[j]^:=tvar;
  end;
end;

procedure sort_by_pc(n:ig;var comp_p:comp_procs);
var i,j:ig;
    tvar:comp_proc;
begin
 for i:=1 to n-1 do
 for j:=i+1 to n do
 if comp_p[i]^.pc<comp_p[j]^.pc then
  begin
   tvar:=comp_p[i]^;
   comp_p[i]^:=comp_p[j]^;
   comp_p[j]^:=tvar;
  end;
end;

procedure sort_by_time(n:ig;var tasks:task_arr);
var i,j:ig;
    tvar:task_rec0;
begin
 for i:=1 to n-1 do
 for j:=i+1 to n do
 if tasks[i]^.tasktime<tasks[j]^.tasktime then
  begin
   tvar:=tasks[i]^;
   tasks[i]^:=tasks[j]^;
   tasks[j]^:=tvar;
  end;
end;

function C1max(duo:ig;var comp_duo:comp_procs;nr_w:ig;var w_task:task_arr):real;
var k:ig;
    c,tw,ts:real;
    tc:real;
begin
 c:=0;
 tw:=0;
 ts:=0;
 for k:=1 to (duo div kp) do
  begin
   if k<=nr_w then tw:=tw+w_task[k]^.tasktime;
   ts:=ts+comp_duo[k*kp]^.speed;
   tc:=tw/ts;
   if c<tc then c:=tc;
  end;
 for k:=(duo div kp)+1 to nr_w do tw:=tw+w_task[k]^.tasktime;
 tc:=tw/ts;
 if c<tc then c:=tc;
 C1max:=c;
end;

function C2max(duo:ig;var comp_duo:comp_procs;
               nr_w:ig;var w_task:task_arr;
               nr_t:ig;var t_task:task_arr):real;
var i,j,k:ig;
    c,tw,ts:real;
    tc:real;
    nr_c_task,nr_c_proc:ig;
    comm_proc:comp_procs;
    comm_task:task_arr;
    tt:task_rec0;

begin
 nr_c_proc:=duo;
 nr_c_task:=kp*nr_w+nr_t;
 for k:=1 to duo do
  begin
   new(comm_proc[k]);
   comm_proc[k]^:=comp_duo[k]^;
   Inc(memory,SizeOf(comp_proc)+SizeOf(comm_proc[k]));
  end;
 for k:=1 to nr_w*kp+nr_t do
  begin
   new(comm_task[k]); {initialize local array}
   Inc(memory,SizeOf(task_rec0)+SizeOf(comm_task[k]));
  end;
 for k:=1 to nr_w do
  for j:=1 to kp do
   comm_task[kp*(k-1)+j]^:=w_task[k]^;
 for k:=1 to nr_t do
   comm_task[kp*nr_w+k]^:=t_task[k]^;
 for i:=1 to nr_c_task-1 do
 for k:=i+1 to nr_c_task do
 if comm_task[i]^.tasktime<comm_task[k]^.tasktime then
  begin
   tt:=comm_task[i]^;
   comm_task[i]^:=comm_task[k]^;
   comm_task[k]^:=tt;
  end;
 c:=0;
 tw:=0;
 ts:=0;
 for k:=1 to nr_c_proc do
  begin
   if k<=nr_c_task then tw:=tw+comm_task[k]^.tasktime;
   ts:=ts+comm_proc[k]^.speed;
   tc:=tw/ts;
   if c<tc then c:=tc;
  end;
 for k:=nr_c_proc+1 to nr_c_task do tw:=tw+comm_task[k]^.tasktime;
 tc:=tw/ts;
 if c<tc then c:=tc;
 C2max:=c;
 for k:=1 to duo do dispose(comm_proc[k]);
 for k:=1 to nr_w*kp+nr_t do dispose(comm_task[k]); {dispose of the local array}
end;

procedure cap_end_time(cmax:real;n:ig;var comp_p:comp_procs);
var i:ig;
begin
 for i:=1 to n do
 with comp_p[i]^ do
 with comp_a[1] do
  begin
   pc:=cmax*speed;
   beg_time:=0;
   end_time:=cmax;
   comp_pc:=pc;
  end;
end;

procedure put_w_res(nr_t:ig;nr_m:ig;var w_task:task_arr;var sched:schedul_rst);
begin
 with sched.schedul[nr_m]^ do
  begin
   nrts:=nrts+1;
   with a[nrts] do
   with w_task[nr_t]^ do
    begin
     tnr:=nr;
     begint:=0;
     endt:=tasktime/pr_speed;
     usestime:=endt-begint;
    end;
  end;
 if w_task[nr_t]^.prcsnum=2 then
  sched.schedul[nr_m+1]^:=sched.schedul[nr_m]^;
end;

procedure put_c_res(var c:comp_el;nr_t:ig;var sched:schedul_rst);
var i:ig;
begin
 with sched.schedul[c.pr_nr]^ do
  begin
   nrts:=nrts+1;
   with a[nrts] do
    begin
     tnr:=nr_t;
     begint:=c.beg_time;
     endt:=c.end_time;
     usestime:=c.end_time-c.beg_time;
    end;
  end;
 if tasks.task_v[nr_t]^.prcsnum>1 then
 for i:=1 to kp-1 do
  sched.schedul[c.pr_nr+i]^:=sched.schedul[c.pr_nr]^;
end;

procedure compr(var duo:ig;var comp_duonew:comp_procs);
var i:ig;
begin
 duo:=duo div kp;
 for i:=1 to duo do comp_duo[i]^:=comp_duo[kp*(i-1)+1]^;
end;

procedure decompr(var duo:ig;var comp_duo:comp_procs);
var i,j,k:ig;
    t_c:comp_procs;
    heapret:pointer;
begin
 for i:=1 to comp.nr_comp_proc do
  begin
   new(t_c[i]);
   Inc(memory,SizeOf(comp_proc)+SizeOf(t_c[i]));
   t_c[i]^:=comp_duo[i]^;
  end;
 for i:=1 to duo do
 for j:=1 to kp do
  begin
   comp_duo[kp*(i-1)+j]^:=t_c[i]^;
   with comp_duo[kp*(i-1)+j]^ do
    begin
     proc_nr:=kp*(i-1)+j;
     for k:=1 to nr_comp do comp_a[k].pr_nr:=comp_a[k].pr_nr+j-1;
    end;
  end;
 duo:=duo*kp;
 for i:=1 to comp.nr_comp_proc do dispose(t_c[i]);
end;


procedure rule1_2_3(var nr_d:ig;var comp_p:comp_procs;
                var nr_w:ig;var w_task:task_arr;
                var sched:schedul_rst);
var i,j,k,l:ig;find,findr1:boolean;u:real;c:comp_el;
    tt:real;

procedure compute_u(var prk,prk1:comp_proc;time:real;nr_t:ig);
var i:ig;nr_c1,nr_c:ig;kdw,k1dw:ig;
    tpc,tpc1:real;speed,speed1:ig;
    beg_time,end_time,u:real;

function tail(var comp_pk:comp_proc;t:real;var nr_c:ig):real;
var i:ig;tpc:real;
begin
 nr_c:=1;
 with comp_pk do
  begin
   tpc:=0;
   while (nr_c<nr_comp) and (comp_a[nr_c].end_time<t) do
    begin
     tpc:=tpc+comp_a[nr_c].comp_pc;
     nr_c:=nr_c+1;
    end;
   with comp_a[nr_c] do if t>beg_time
   then tail:=pc-tpc-(t-beg_time)*comp_speed
   else tail:=pc;
  end;
end;

function head(var comp_pk:comp_proc;t:real;var nr_c:ig):real;
var i:ig;tpc:real;
begin
 nr_c:=1;
 with comp_pk do
  begin
   tpc:=0;
   while (nr_c<nr_comp) and (comp_a[nr_c].end_time<t) do
    begin
     tpc:=tpc+comp_a[nr_c].comp_pc;
     nr_c:=nr_c+1;
    end;
   with comp_a[nr_c] do head:=tpc+(t-beg_time)*comp_speed;
  end;
end;

procedure connect(var prk,prk1:comp_proc;n,n1:ig;u:real;nr_t:ig);
var i:ig;c:comp_el;
begin
 for i:=1 to n-1 do put_c_res(prk.comp_a[i],nr_t,sched);
 c:=prk.comp_a[n];
 with c do
  begin
   end_time:=u;
   comp_pc:=(end_time-beg_time)*comp_speed;
  end;
 put_c_res(c,nr_t,sched);
 if n1>0 then
  begin
   c:=prk1.comp_a[n1];
   with c do
    begin
     beg_time:=u;
     comp_pc:=(end_time-beg_time)*comp_speed;
    end;
   put_c_res(c,nr_t,sched);
  end;
 for i:=n1+1 to prk1.nr_comp do put_c_res(prk1.comp_a[i],nr_t,sched);
 with prk1 do
  begin
   if n1>0 then with comp_a[n1] do
    begin
     end_time:=u;
     comp_pc:=(end_time-beg_time)*comp_speed;
    end;
   nr_comp:=n1;
   with prk.comp_a[n] do
    begin
     beg_time:=u;
     comp_pc:=(end_time-beg_time)*comp_speed;
     if comp_pc<re then n:=n+1;
    end;
   for i:=1 to (prk.nr_comp-n+1) do comp_a[nr_comp+i]:=prk.comp_a[n+i-1];
   nr_comp:=nr_comp+(prk.nr_comp-n+1);
   pc:=0;
   for i:=1 to nr_comp do pc:=pc+comp_a[i].comp_pc;
  end;
 prk:=prk1;
end;

begin
 with prk do
  begin
   tpc:=comp_a[1].comp_pc;
   kdw:=1;nr_c:=1;
   while (kdw<nr_comp) and ((tpc+tail(prk1,comp_a[kdw+1].beg_time,nr_c))<time) do
    begin
     kdw:=kdw+1;
     tpc:=tpc+comp_a[kdw].comp_pc;
    end;
   tpc:=tpc-comp_a[kdw].comp_pc;
  end;

  with prk1 do
   begin
    tpc1:=0;
    k1dw:=nr_comp;
    while (k1dw>0) and ((tpc1+comp_a[k1dw].comp_pc+head(prk,comp_a[k1dw].beg_time,nr_c1))>=time) do
     begin
      tpc1:=tpc1+comp_a[k1dw].comp_pc;
      k1dw:=k1dw-1;
     end;
   end;
  if k1dw>0 then
   begin
    speed1:=prk1.comp_a[k1dw].comp_speed;
    end_time:=prk1.comp_a[k1dw].end_time;
   end
  else
   begin
    speed1:=0;
    end_time:=0;
   end;
  beg_time:=prk.comp_a[kdw].beg_time;
  speed:=prk.comp_a[kdw].comp_speed;
  {if speed=speed1 then anykey;}
  u:=(time-tpc-tpc1+speed*beg_time-speed1*end_time)/(speed-speed1);
  connect(prk,prk1,kdw,k1dw,u,nr_t);
end;  { compute_u }

begin
 while nr_w>0 do
  begin
   k:=0;
   findr1:=false;
   while (k<nr_d) and not findr1 do
    begin
     k:=k+1;
     if (abs(comp_p[k]^.pc-w_task[1]^.tasktime)<re) and
     ((k=nr_d) or (abs(comp_p[k+1]^.pc-w_task[1]^.tasktime)>0.001)) then findr1:=true;
    end;
   if findr1 then            { rule 1 }
    begin
     with comp_p[k]^ do
      begin
       for j:=1 to nr_comp-1 do
       for l:=j+1 to nr_comp do
       if comp_a[j].beg_time>comp_a[l].beg_time then
        begin
         c:=comp_a[j];comp_a[j]:=comp_a[l];comp_a[l]:=c
        end;
       while (nr_comp>0) do
        begin
         put_c_res(comp_a[1],w_task[1]^.nr,sched);
         for l:=1 to nr_comp-1 do comp_a[l]:=comp_a[l+1];
         nr_comp:=nr_comp-1;
        end;
       for j:=1 to nr_w-1 do w_task[j]^:=w_task[j+1]^;
       nr_w:=nr_w-1;
       for j:=k to nr_d-1 do comp_p[j]^:=comp_p[j+1]^;
       nr_d:=nr_d-1;
      end;
    end
   else
    begin
     k:=0;
     find:=false;
     while (k<nr_d-1) and not find  do
      begin
       k:=k+1;
       if (comp_p[k]^.pc>w_task[1]^.tasktime) and (comp_p[k+1]^.pc<w_task[1]^.tasktime) then find:=true;
      end;
     if find then            { rule 2 }
      begin
       compute_u(comp_p[k]^,comp_p[k+1]^,w_task[1]^.tasktime,w_task[1]^.nr);
       for j:=1 to nr_w-1 do w_task[j]^:=w_task[j+1]^;
       nr_w:=nr_w-1;
       for j:=k to nr_d-1 do comp_p[j]^:=comp_p[j+1]^;
       nr_d:=nr_d-1;
      end
     else                    { rule 3 }
     with comp_p[nr_d]^ do
      begin
       for j:=1 to nr_comp-1 do
       for k:=j+1 to nr_comp do
       if comp_a[j].beg_time>comp_a[k].beg_time then
        begin
         c:=comp_a[j];comp_a[j]:=comp_a[k];comp_a[k]:=c
        end;
       tt:=w_task[1]^.tasktime;
       while (nr_comp>0) and (tt>0) do if tt>=comp_a[1].comp_pc then
        begin
         put_c_res(comp_a[1],w_task[1]^.nr,sched);
         pc:=pc-comp_a[1].comp_pc;
         tt:=tt-comp_a[1].comp_pc;
         for k:=1 to nr_comp-1 do comp_a[k]:=comp_a[k+1];
         nr_comp:=nr_comp-1;
        end
       else
        begin
         c:=comp_a[1];
         c.end_time:=c.beg_time+tt/c.comp_speed;
         c.comp_pc:=tt;
         put_c_res(c,w_task[1]^.nr,sched);
         comp_a[1].beg_time:=c.end_time;
         comp_a[1].comp_pc:=comp_a[1].comp_pc-tt;
         pc:=pc-tt;
         tt:=0;
        end;
       for j:=1 to nr_w-1 do w_task[j]^:=w_task[j+1]^;
       nr_w:=nr_w-1;
       if nr_comp=0 then nr_d:=nr_d-1;
      end;
    end;
  end;
end; { rule2 }


procedure dp(var nr_d:ig;var comp_p:comp_procs;
                var nr_t:ig;var t_task:task_arr;
                var sched:schedul_rst;
                var x,nrpd:ig;var tab_nrdp:nrdp_arr;var tab_dp:dp_arr);
var g,i,j:ig;
    tdp,tt,tpc:real;tx:ig;

function r_sch(x:ig):real;
var i:ig;
    t:real;
begin
 t:=0;
 if x>0 then
  begin
   with sched do
   with schedul[x]^ do
   for i:=1 to nrts do t:=t+a[i].usestime;
  end;
 r_sch:=sched.c-t;
end;

begin
 tdp:=-999999;
 tt:=0;tpc:=0;x:=0;nrpd:=0;
 g:=0;
 while (g<nr_d) and (g<nr_t) do
  begin
   g:=g+1;
   tt:=tt+t_task[g]^.tasktime;
   tpc:=tpc+comp_p[g]^.pc;
   if (tt-tpc)>re then
    begin
     tdp:=tt-tpc;
     if tdp>re then
      begin
       x:=comp_p[g]^.comp_a[comp_p[g]^.nr_comp].pr_nr;
       nrpd:=nrpd+1;
       tab_dp[nrpd]:=tdp;
       tab_nrdp[nrpd]:=comp_p[g]^.comp_a[1].pr_nr;
       tt:=0;tpc:=0;
      end;
    end;
  end;
 if x=0 then
  begin
   j:=g+1;
   while (j<=nr_t) do
    begin
     tt:=tt+t_task[j]^.tasktime;
     if (tt-tpc)>re then
      begin
       tdp:=tt-tpc;
       if tdp>re then
        begin
         x:=comp_p[g]^.comp_a[comp_p[g]^.nr_comp].pr_nr;
         nrpd:=nrpd+1;
         tab_dp[nrpd]:=tdp;
         tab_dp[nrpd]:=comp_p[g]^.comp_a[1].pr_nr;
         tt:=0;tpc:=0;
        end;
      end;
     j:=j+1;
    end;
  end;
 if x>0 then
  begin
   x:=(x div kp)*kp+1;
   while (x>1) and (abs(r_sch(x-1))<re) do x:=x-1;
  end;
end; { dp }

function delta(x,nrpd:ig;var tab_nrdp:nrdp_arr;var tab_dp:dp_arr;
               var c:comp_rec;duo:ig;var comp_p:comp_procs):real;
var i,endp,g,y:ig;
    tsu,tsd:lig;fin:boolean;
    max_delta,temp_delta:real;
begin
 i:=0;fin:=false;max_delta:=0;
 while (i<duo) and not fin do
  begin
   i:=i+1;
   with comp_p[i]^ do
   if nr_comp>0 then
   with comp_a[1] do
    begin
     if (pr_nr>=tab_nrdp[1]) and (comp_a[1].beg_time=0)
     and (comp_a[nr_comp].end_time=cmax) then fin:=true;
    end;
  end;
 if fin then endp:=(((tab_nrdp[1]-1) div kp)+1)*kp
 else endp:=c.nr_comp_proc;
 with c do
  begin
   tsu:=0;
   for i:=1 to x-1 do tsu:=tsu+comp_pr[i]^.speed;
   tsd:=0;
   for i:=x to endp do tsd:=tsd+comp_pr[i]^.speed;
   for g:=1 to nrpd do
    begin
     y:=((tab_nrdp[g]-1) mod kp)+g;
     temp_delta:=tab_dp[g]/(tsu+((y*tsd)/kp));
     if temp_delta>max_delta then max_delta:=temp_delta;
    end;
  end;
 delta:=max_delta;
end;                  { delta }


begin					  {k_proc}
 memory:=0;
 for i:=1 to MaxN do
  begin
   k_task[i]:=nil;
   t_task[i]:=nil;
  end;
 gettime(hr,mn,sc,sc100);
 with comp do
 begin
  for i:=1 to nr_comp_proc-1 do for j:=i+1 to nr_comp_proc do
	if comp_pr[j]^.speed>comp_pr[i]^.speed then
	 begin
	  tmp_proc:=comp_pr[i]^;
		comp_pr[i]^:=comp_pr[j]^;
		comp_pr[j]^:=tmp_proc;
	 end;
  for i:=1 to nr_comp_proc do with comp_pr[i]^ do
	 begin
	  proc_nr:=i;
		comp_a[1].pr_nr:=i;
	 end;
 end;
 with tasks do
  begin
   for i:=1 to n-1 do
   for j:=i+1 to n do
	 if task_v[j]^.tasktime>task_v[i]^.tasktime then
	  begin
	   tmp_task:=task_v[i]^;
		 task_v[i]^:=task_v[j]^;
		 task_v[j]^:=tmp_task;
	  end;
	 for i:=1 to n do task_v[i]^.nr:=i;
  end;
 sort_by_speed(comp.nr_comp_proc,comp.comp_pr);
 sched.m:=comp.nr_comp_proc;
 setrst(sched,comp);
 make_k_t_task(tasks,nr_kp,k_task,nr_t,t_task);
 for i:=1 to comp.nr_comp_proc do
  begin
   new(comp_duo[i]);
   Inc(memory,SizeOf(comp_proc)+SizeOf(comp_duo[i]));
   comp_duo[i]^:=comp.comp_pr[i]^;
  end;
 duo:=comp.nr_comp_proc;
 sort_by_speed(duo,comp_duo);
 sort_by_time(nr_kp,k_task);
 sort_by_time(nr_t,t_task);
 c1:=c1max(duo,comp_duo,nr_kp,k_task);
 c2:=c2max(duo,comp_duo,nr_kp,k_task,nr_t,t_task);
 if c1>c2 then cmax:=c1 else cmax:=c2;
 sched.c:=cmax;
 cap_end_time(cmax,duo,comp_duo);
 compr(duo,comp_duo);
 rule1_2_3(duo,comp_duo,nr_kp,k_task,sched);
 decompr(duo,comp_duo);
 dp(duo,comp_duo,nr_t,t_task,sched,x,nrpd,tab_nrdp,tab_dp);
 nr_cmax:=1;a_cmax[1]:=cmax;
 while x>0 do
  begin
   nr_cmax:=nr_cmax+1;
   cmax:=cmax+delta(x,nrpd,tab_nrdp,tab_dp,comp,duo,comp_duo);
   a_cmax[nr_cmax]:=cmax;
   setrst(sched,comp);
   make_k_t_task(tasks,nr_kp,k_task,nr_t,t_task);
   for i:=1 to comp.nr_comp_proc do comp_duo[i]^:=comp.comp_pr[i]^;
   duo:=comp.nr_comp_proc;
   sort_by_speed(duo,comp_duo);
   sort_by_time(nr_kp,k_task);
   sort_by_time(nr_t,t_task);
   sched.c:=cmax;
   cap_end_time(cmax,duo,comp_duo);
   compr(duo,comp_duo);
   rule1_2_3(duo,comp_duo,nr_kp,k_task,sched);
   decompr(duo,comp_duo);
   dp(duo,comp_duo,nr_t,t_task,sched,x,nrpd,tab_nrdp,tab_dp);
  end;
 rule1_2_3(duo,comp_duo,nr_t,t_task,sched);
 workt:=getsec(hr,mn,sc,sc100);
 with sched do
 for i:=1 to m do
 with schedul[i]^ do
 for j:=1 to nrts-1 do
 for k:=j+1 to nrts do
 if a[j].begint>a[k].begint then
  begin
   t_ra:=a[j];
   a[j]:=a[k];
   a[k]:=t_ra;
  end;
 for i:=1 to comp.nr_comp_proc do
  begin
   dispose(comp_duo[i]);
  end;
 for i:=1 to MaxN do
  begin
   if k_task[i]<>nil then dispose(k_task[i]);
   if t_task[i]<>nil then dispose(t_task[i]);
  end;
end;             { K_proc}

end.


