{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : LPT                                                           *}
{*                                                                           *}
{*  This unit contains procedure implementing LPT                         *}
{*  scheduling algorithm.                                                    *}
{*                                                                           *}
{*****************************************************************************}

unit LPT;

{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses WinProcs,WinDos,Deklar,Tools,ToolHelp;

procedure LPT1(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real; kp:ig);
{ Parametrs given:
     task - tasks set,
     comp - processor set,
     kp   - number of processors executing widest multiprocessor task,
  Parametrs returned:
     sched - schedule description,
     workt - how long schedule was computed}

implementation

procedure LPT1(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real;kp:ig);
type
 pend = record
         idx:Integer;
         ft:real;
        end;

 pTEB = record
         begt,endt:Real;
        end;

var
        Tsk:Task_rec;
        Com:Comp_rec;
        E:array [1..MaxM] of pend;
        TEB: array[1..MaxN] of pTEB;
	hr,mn,sc,sc100:word;
	i,j,k,np,nt:ig;
        Cmax:Real;
        ActualProc:Integer;


function IsAvailable(T:task_rec0):Boolean;
var
 i:Integer;
 constr:ptrprem;
begin
  IsAvailable:=true;
  For i:=1 to Tsk.n do
  if (Tsk.task_v[i]^.next<>nil)and(Tsk.task_v[i]^.nr<>T.nr)then
  begin
   constr:=Tsk.task_v[i]^.next;
   repeat
    if (T.nr=constr^.nrprem)then
    begin
     IsAvailable:=False;
     exit
    end;
    constr:=constr^.next
   until constr=nil;
  end;

  for i:=1 to tasks.n do
  if tasks.task_v[i]^.next <>nil then
  begin
   constr:=tasks.task_v[i]^.next;
   repeat
   if (T.nr=constr^.nrprem)and
      (TEB[Tasks.task_v[i]^.nr].endt>E[1].ft)then
        begin
         IsAvailable:=False;
         exit;
        end;
        Constr:=Constr^.next;
   until constr=nil;
  end;
end;

procedure DelTask(X:Integer);
var
 i:Integer;
begin
 with tsk do
 begin
   for i:=X to n-1 do
   task_v[i]^:=task_v[i+1]^;
   dec(n);
 end;
end;

procedure SortE;
var
 i,j:integer;
 temp:pend;
begin
with com do
 for i:=2 to nr_comp_proc do
  for j:=nr_comp_proc downto i do
    if E[j-1].ft>E[j].ft then
    begin
     temp:=E[j-1];
     E[j-1]:=E[j];
     E[j]:=temp;
    end;
end;

procedure incE1;
var
 i:Integer;
begin
 i:=1;
 Repeat
  i:=i+1;
 until (E[1].ft<E[i].ft) or (i=com.nr_comp_proc);
 E[1].ft:=e[i].ft;
end;

procedure InitDuplik(var T:task_rec;var C:comp_rec);
var
i:Integer;
begin
 For i:=1 to Comp.nr_comp_proc do
 begin
  new(C.comp_pr[i]);
  C.comp_pr[i]^:=Comp.Comp_pr[i]^;
 end;
 C.nr_comp_proc:=Comp.nr_comp_proc;
 For i:=1 to tasks.n do
 begin
  new(T.task_v[i]);
  T.task_v[i]^:=tasks.task_v[i]^;
 end;
 T.n:=tasks.n;
 T.nr_k:=tasks.nr_k;
end;

procedure SortTask(var t:task_rec);
var
 i,j:integer;
 p:task_ptr;
begin
  with t do
  begin
   for i:=2 to n do
    for j:=n downto i do
    if task_v[j-1]^.tasktime<task_v[j]^.tasktime then
    begin
     p:=task_v[j-1];
     task_v[j-1]:=task_v[j];
     task_v[j]:=p;
    end;
  end;
end;


procedure AssTask(task_nr:Integer);
var
 TimeNotUsed:Real;
 ProcNr:Integer;
 TDue,temp:Real;
begin
  with sched.schedul[E[1].idx]^ do
  begin
   nrts:=nrts+1;
   a[nrts].tnr:=tsk.task_v[task_nr]^.nr;
   a[nrts].begint:=E[1].ft;
   a[nrts].usestime:=tsk.task_v[task_nr]^.tasktime;
   a[nrts].endt:=E[1].ft+tsk.task_v[task_nr]^.tasktime;
   TEB[tsk.task_v[task_nr]^.nr].begt:=E[1].ft;
   E[1].ft:=E[1].ft+tsk.task_v[task_nr]^.tasktime;
   TEB[tsk.task_v[task_nr]^.nr].endt:=E[1].ft;
  end;
end;

begin
 initsched(sched,1,comp.nr_comp_proc);
 InitDuplik(Tsk,Com);
 gettime(hr,mn,sc,sc100);
 SortTask(tsk);
 ActualProc:=1;
 with tsk do
 with com do
 with sched do
 begin
  for i:=1 to nr_comp_proc do
   begin
    E[i].idx:=i;
    E[i].ft:=0;
   end;
  repeat
   i:=0;
   sortE;
   repeat
    i:=i+1;
   until (IsAvailable(Tsk.task_v[i]^))or(i=tsk.n);
   if not(IsAvailable(Tsk.task_v[i]^))then incE1 else
   begin
    AssTask(i);
    DelTask(i);
   end;
  until n=0;
  Cmax:=0;
  for i:=1 to nr_comp_proc do
  if E[i].ft>=Cmax then Cmax:=E[i].ft;
  c:=Cmax;
  workt:=getsec(hr,mn,sc,sc100);
  is_act_sch:=true;
  memory:=0;
  For i:=1 to n do
  Dispose(tsk.task_v[i]);
  For i:=1 to nr_comp_proc do
  Dispose(com.comp_pr[i]);
 end;
end;
end.