{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : McN                                                            *}
{*                                                                           *}
{*  This unit contains procedure implementing McNaughton's                   *}
{*  scheduling algorithm.                                                    *}
{*                                                                           *}
{*****************************************************************************}

unit McN;

{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses WinProcs,WinDos,Deklar,Tools,ToolHelp;

procedure Mcns(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real; kp:ig);
{ Parametrs given:
     task - tasks set,
     comp - processor set,
     kp   - number of processors executing widest multiprocessor task,
  Parametrs returned:
     sched - schedule description,
     workt - how long schedule was computed}

implementation

procedure Mcns(tasks:task_rec; comp:comp_rec; var sched:schedul_rst;var workt:real;kp:ig);
var
	ext,Cmax:real;
	hr,mn,sc,sc100:word;
	i,j,k,np,nt:ig;
	tt: real;
	ch:char;
	equal,low,great:boolean;

function searchmaxp(tasks:task_rec):real;
{ This function returns the longest task's processing time }
var
	i:ig;
	maxp:real;
begin
 with tasks do
	begin
	 maxp:=0;
	 for i:=1 to n do
	 with task_v[i]^ do
	 if tasktime>maxp then maxp:=tasktime;
	end;
 searchmaxp:=maxp;
end;



begin
 with tasks do
 with comp do
 with sched do
	begin
	 gettime(hr,mn,sc,sc100);

{ Finding Cmax* }
   ext:=searchmaxp(tasks);
	 Cmax:=0;
	 for i:=1 to n do Cmax:=Cmax+task_v[i]^.tasktime;
	 Cmax:=Cmax/nr_comp_proc;
	 if ext>Cmax then Cmax:=ext;
	 c:=Cmax;
	 m:=nr_comp_proc;
	 initsched(sched,1,nr_comp_proc);

{ Assigning tasks to processors }
   np:=1;
	 for nt:=1 to n do
	 with task_v[nt]^ do
		begin
		 with schedul[np]^ do
			begin
			 nrts:=nrts+1;
			 if nrts>1 then a[nrts].begint:=a[nrts-1].endt
			 else a[1].begint:=0;
			 a[nrts].tnr:=nt;
			 low:=((a[nrts].begint+tasktime)<Cmax);
			 equal:=((a[nrts].begint+tasktime)=Cmax);
			 great:=((a[nrts].begint+tasktime)>Cmax);
			 if low then { A task fits in the interval 0..Cmax }
			 with a[nrts] do
				begin
				 endt:=begint+tasktime;
				 usestime:=tasktime;
				end;
			 if equal then {The tasks fill completely 0..Cmax interval }
				begin
				 with a[nrts] do
				  begin
				   endt:=Cmax;
				   usestime:=tasktime;
				  end;
				 end_time:=Cmax;
				 np:=np+1;
				end;
			end;
		 if great then   {The task doesn't fit in 0..Cmax interval}
			begin
			 with schedul[np]^ do
			  begin
			   with a[nrts] do
			    begin
			     endt:=Cmax;
			     usestime:=Cmax-begint;
			     tt:=tasktime-usestime;
			    end;
			   end_time:=Cmax;
			  end;
			 np:=np+1;
			 with schedul[np]^ do
			  begin
			   nrts:=1;
			   with a[1] do
			    begin
			     tnr:=nt;
     			     begint:=0;
                             endt:=tt;
  		             usestime:=tt;
               		    end;
			 end;
 		     end;
		 end;
		workt:=getsec(hr,mn,sc,sc100);
            	is_act_sch:=true;
                memory:=0;
       	end;
end;


end.