{$I PCoption}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

unit Print;

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Print                                                          *}
{*                                                                           *}
{*  This unit write schedule data and results to the file                    *}
{*                                                                           *}
{*                                                                           *}
{*****************************************************************************}

interface

uses WinDos,Deklar,Tools,Objects;

procedure PrintResult(var sched:schedul_rst;workt:real;var FName: PChar);

{* This procedure writes to the file named 'work.' results of scheduling  *}
{* given in sched recod. Value of workt is an execution time of the          *}
{* scheduling algorithm.                                                     *}

procedure PrintTask(var tasks:task_rec;var comp:comp_rec;var FName: PChar);

{* This procedure writes to the file named 'work.' given data set, ie.    *}
{* tasks from record task and processors from record comp.                   *}


implementation

procedure PrintResult(var sched:schedul_rst;workt:real;var FName: PChar);
var i,j:ig;
    rob:text;
begin
 Assign(rob,FName);
 Rewrite (rob);
 with sched do with schedul[1]^ do
  begin
   write(rob,'     Cmax =');
   writeln(rob,c:10:4);
   writeln(rob,'');
   write(rob,'     Time =');
   writeln(rob,a[1].usestime:10:4);
   write(rob,'     Memory :');
   writeln(rob,memory);
   writeln(rob,'');

  end;
 writeln(rob,'  ');
 with sched do
  begin
   for i:=1 to m do
   with schedul[i]^ do
    begin
     write(rob,'Processor number:');write(rob,i:4);
     write(rob,'  Speed  :');writeln(rob,pr_speed:8);
     {if criterion='Cmax' then
      begin
       write(rob,'     Cmax =');
       writeln(rob,c:10:4);
      end
     else
      begin
       write(rob,'     Lmax =');
       writeln(rob,lmax:10:4);
      end;}
     writeln(rob,'===================================================================');
     writeln(rob,'');
     writeln(rob,'Task number         Begin of execution           End of execution');
     for j:=1 to nrts do with a[j] do
      begin
       write(rob,tnr:5);write(rob,'                      ');
       write(rob,begint:10:4);
       write(rob,'                 ');
       writeln(rob,begint+usestime:10:4);
      end;
     writeln(rob,'');
    end;
  end;
 Close(rob);
end;

procedure PrintTask(var tasks:task_rec;var comp:comp_rec;var FName: PChar);
var i,j:ig;
    f:text;
    nx:ptrprem;

begin
 Assign(f,FName);
 Rewrite(f);
 writeln(f,'T A S K S :');
 writeln(f,'Task#  Processing time  Ready time  Due-date  # of processors  Req. processors');{lv;}
 with tasks do
 for i:=1 to n do
 with task_v[i]^ do
  begin
   write(f,i:4,tasktime:14:2,rdytime:14:2,ddate:14:2,prcsnum:8,'     ');
   printset(f,dedication);
   writeln(f);
  end;
 writeln(f,'P R O C E S S O R S:');
 writeln(f,'Number   Speed');
 with comp do
 for i:=1 to nr_comp_proc do
 with comp_pr[i]^ do
  begin
   writeln(f,i:3,speed:13);
  end;
 if gen.succ_g<>nosucc then
  begin
   writeln(f,'P R E C E D E N C E  C O N S T R A I N T S');
   writeln(f,'Predecessor   Succesor');
   j:=1;
   with tasks do
   for i:=1 to n do
   with task_v[i]^ do
    begin
     nx:=next;
     while nx<>nil do
      begin
       writeln(f,i:3,nx^.nrprem:14);
       j:=j+1;
       nx:=nx^.next;
      end;
    end;
  end;
 Close(f);
end;

end.
