{$I PCoption}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

unit PrintObj;

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : PrintObj                                                       *}
{*                                                                           *}
{*  This unit enables to print.                                              *}
{*                                                                           *}
{*****************************************************************************}

interface

uses WinDos,WinProcs,OPrinter,Objects,OWindows,WinTypes,ConsObj,
       Ostdwnds,Strings;
 type

  PPCharCollection = ^TPCharCollection;
  TPCharCollection = object(TCollection)
    procedure FreeItem(Item: Pointer); virtual;
  end;



  PTextPrint = ^TTextPrint;
  TTextPrint = object(TPrintout)
   TextHeight, LinesPerPage, FirstOnPage, LastOnPage: Integer;
   TheLines: PCollection;
   constructor Init(ATitle: PChar; TheText: PPCharCollection);
   function GetDialogInfo(var Pages: Integer): Boolean; virtual;
   function HasNextPage(Page: Word): Boolean; virtual;
   procedure SetPrintParams(ADC: HDC; ASize: TPoint); virtual;
   procedure PrintPage(Page: Word; var Rect: TRect; Flags: Word); virtual;
 end;

  PPrintWindow = ^TPrintWindow;
  TPrintWindow = object(TFileWindow)
   Printer: PPrinter;
   FileLines: PPCharCollection;
   constructor Init(AParent: PWindowsObject; ATitle: PChar);
   procedure CMPrint(var Msg: TMessage;const device: Byte;var TextName: PChar); virtual cm_First + cm_Print;
   procedure CMSetup(var Msg: TMessage); virtual cm_First + cm_Setup;
   procedure LoadFile(var TextName: PChar);
   destructor Done; virtual;
  end;


implementation

constructor TTextPrint.Init(ATitle: PChar; TheText: PPCharCollection);
begin
  inherited Init(ATitle);
  TheLines := TheText;
  FirstOnPage := 0;
  LastOnPage := 0;
end;


function TTextPrint.GetDialogInfo(var Pages: Integer): Boolean;
begin
  Pages := TheLines^.Count div LinesPerPage + 1;
  GetDialogInfo := True;
end;

function TTextPrint.HasNextPage(Page: Word): Boolean;
begin
  HasNextPage := LastOnPage < TheLines^.Count - 1;
end;

procedure TTextPrint.SetPrintParams(ADC: HDC; ASize: TPoint);
var
  TextMetrics: TTextMetric;
begin
  inherited SetPrintParams(ADC, ASize);
  GetTextMetrics(DC, TextMetrics);
  TextHeight := TextMetrics.tmHeight;
  LinesPerPage := Size.Y div TextHeight;
end;

procedure TTextPrint.PrintPage(Page: Word; var Rect: TRect; Flags: Word);
var
  Line: Integer;
  TheText: PChar;
begin
  FirstOnPage := (Page - 1) * LinesPerPage;
  LastOnPage := (Page * LinesPerPage) - 1;
  if LastOnPage >= TheLines^.Count then LastOnPage := TheLines^.Count - 1;
  for Line := FirstOnPage to LastOnPage do
  begin
    TheText := TheLines^.At(Line);
    if TheText <> nil then
      TextOut(DC, 0, (Line - FirstOnPage) * TextHeight, TheText, StrLen(TheText));
  end;
end;


procedure TPCharCollection.FreeItem(Item: Pointer);
begin
  StrDispose(PChar(Item));
end;



 procedure TPrintWindow.LoadFile(var TextName: PChar);
var
  TextLine: array[0..255] of Char;
  TextFile: Text;
begin
  if Assigned(FileLines) then Dispose(FileLines, Done);
  FileLines := New(PPCharCollection, Init(100, 10));
  Assign(TextFile,TextName);
  Reset(TextFile);
  while not eof(TextFile) do
  begin
    Readln(TextFile, TextLine);
    FileLines^.Insert(StrNew(TextLine));
  end;
  Close(TextFile);
end;

destructor TPrintWindow.Done;
begin
  if Assigned(FileLines) then Dispose(FileLines, Done);
  inherited Done;
end;


procedure TPrintWindow.CMPrint(var Msg: TMessage;const device: Byte;var TextName: PChar);
var
  P: PPrintOut;
begin
  if device = 1 then
   begin
    LoadFile(TextName);
    P := New(PTextPrint, Init(TextName, FileLines));
    Printer^.Print(@Self, P);
    Dispose(P, Done);
   end
  else
   if device = 2 then
    begin
     LoadFile(TextName);
     P := New(PTextPrint, Init(TextName, FileLines));
     Printer^.Print(@Self, P);
     Dispose(P, Done);
    end
end;


procedure TPrintWindow.CMSetup(var Msg: TMessage);
begin
  Printer^.Setup(@Self);
end;


constructor TPrintWindow.Init(AParent: PWindowsObject; ATitle: PChar);
 begin
  Inherited Init(AParent, ATitle,nil);
  FileLines := New(PPCharCollection, Init(10, 10));
  Printer := New(PPrinter, Init);
 end;

end.