
 unit TaskGen;

{*****************************************************************************}
{*                                                                           *}
{*  Program : Simul                                                          *}
{*  Unit    : Taskgen                                                        *}
{*                                                                           *}
{*  This unit contains procedures for both introduction and random           *}
{*  generation of tasks and processors sets.                                 *}
{*  Random generation functions are accesible outside the unit.              *}
{*                                                                           *}
{*****************************************************************************}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses WinDos,WinCrt,WinProcs,Deklar,Tools,Strings,WinApi;

const mult=3125;

var rndnum:real;

function rnd01:real;
{Uniform distribution generator of random numbers in range [0,1) }

function rnd_norm:real;
{Normal distribution generator }

function rnd_exp(lambda:real):real;
{Exponential distribution generator}

procedure gen_proc(gd:gendata; var comp:comp_rec;kp:ig);
{ Random generation of processors set (comp).
  Number of processors in variable nr_comp_proc in record comp
  Number of processors per multiprocessor task - kp}

procedure gen_task(gen:generate;var task:task_rec;m,kp:ig);
{ Random generation of parameters of the tasks set.}

procedure gen_prem(gen:generate;var task:task_rec);
{ Precedence constraints generation. For every task succesors list is created
  This procedure must be executed as the last one from among
  gen_proc, gen_task procedures}

procedure generate_data;
{ Generation of all data sets basing on the given decriptions in record
  gen:generate }

(*procedure read_task(var gen:generate;var task:task_rec;var comp:comp_rec;var kp:ig);*)
{ Tasks sets (task) and processors sets (comp) introduction procedure.}

function generator(how:gendatatype; par:real):real;
{ Generates value with probability distribution given by how with parameter par}

procedure mix(var tab:succtab; n:ig);
{ Generates unique numbers from interval 1..n to the table tab}


implementation

function rnd01:real;
var tv:real;
begin
     tv:=rndnum*mult;
     tv:=tv-trunc(tv);
     rndnum:=tv;
     rnd01:=tv
end;

function rnd_norm:real;
var i:integer;rndn:real;
begin
     rndn:=0;
     for i:=1 to 12 do rndn:=rndn+rnd01;
     rnd_norm:=rndn-6;
end;
function rnd_exp(lambda:real):real;
var r:real;
begin
     r:=rnd01;
     rnd_exp:=-(1/lambda)*ln(r);
end;


procedure gen_proc(gd:gendata;var comp:comp_rec;kp:ig);
var i,j:ig;
    t_proc:comp_proc;
begin
 is_act_proc:=true;
 if gd.form=data then exit;
 with comp do
  begin
   for i:=1 to nr_comp_proc do
    begin
		 if comp_pr[i]=nil then new(comp_pr[i]);
     with comp_pr[i]^ do
      begin
       proc_nr:=i;
       pc:=0;
       nr_comp:=1;
       speed:=0;
       comp_a[1].pr_nr:=i;
       comp_a[1].beg_time:=0;
       if ((i mod kp)=1) or (kp=1) then
        begin
				 if gd.form=cons then speed:=trunc(gd.par1)
				 else speed:=1+trunc(gd.par1*generator(gd.form,gd.par2));
         comp_a[1].comp_speed:=speed;
        end
       else
        begin
         speed:=comp_pr[((i-1) div kp)*kp+1]^.speed;
         comp_a[1].comp_speed:=speed;
        end;
      end;
    end;
  end;
end;

procedure gen_task(gen:generate;var task:task_rec;m:ig;kp:ig);
 var
   i,j,i1:ig;
   t_task:task_rec0;
   ok:boolean;
   s:fs;
   tab:array[1..max_comp] of ig;
   poz_tab:ig;
   s1,s2:string;
   ch: PChar;

begin
 is_act_task:=true;
 poz_tab:=3;
 tab[1]:=kp;
 tab[2]:=1;
 with gen do
 with task do
  begin
   for i:=1 to n do
    begin
     if task_v[i]=nil then new(task_v[i]);
     with task_v[i]^ do
      begin
       if task_p.form<>data then
       if task_p.form=cons then tasktime:=task_p.par1
        else tasktime:=1+task_p.par1*generator(task_p.form,task_p.par2);
       if task_r.form<>data then
       if task_r.form=cons then rdytime:=task_r.par1
       else rdytime:=(task_r.par1+1)*generator(task_r.form,task_r.par2);
       if task_d.form<>data then
       if task_d.form=cons then ddate:=task_d.par1
       else ddate:=1+task_d.par1*generator(task_d.form,task_d.par2);
       if task_k.form<>data then
        begin
         if task_k.form=cons then
          begin
           if task_k.par1=1.0 then prcsnum:=1
           else prcsnum:=kp
          end
	 else
	  begin
	   ok:=false;
	   while not ok do
	    begin        {Here random number of processors}
	     prcsnum:=round(task_k.par1*generator(task_k.form,task_k.par2));
	     if (prcsnum>0) and (prcsnum<=kp) then
  	      begin
	       ok:=true;
	       j:=1;
	       while (j<poz_tab) and (ok) do
	        begin
	         if tab[j]>prcsnum then
	          begin
		   if (tab[j] mod prcsnum)<>0 then
		    ok:=false
		  end
		 else if (prcsnum mod tab[j])<>0 then ok:=false;
		 inc(j);
	      end;
	    end;
	  end;
	  ok:=false;
	  for j:=1 to poz_tab-1 do if tab[j]=prcsnum then ok:=true;
	   if not ok then
	    begin
	     tab[poz_tab]:=prcsnum;
	     inc(poz_tab);
	    end;
       end;
        end;
       if task_ded.form<>data then {Here dedication is generated}
        begin  {Here must not be prcsnum<>1 and task_ded.form=const -makes no sense}
         if task_ded.form=cons then
          begin
           if task_ded.par1=0 then dedication:=[]
           else dedication:=[round(task_ded.par1)]
          end
         else
          begin
           s:=[];
           if task_ded.par1<prcsnum then
            begin
             is_act_task:=false;
             s1:='More processors required by task ';
             str(i,s2);
             s1:=Concat(s1,s2);
             s1:=Concat(s1,' then then given in distribution of q');
             StrPCopy(ch,s1);
             MessageBox(0,nil,ch, mb_OK);
             exit;
            end
           else while cardinality(s)<>prcsnum do
            begin
             i1:=round(task_ded.par1*generator(task_ded.form,task_k.par2));
             if (i1<=m) and (i1>0) then s:=s+[i1];
            end;
           dedication:=s;
          end;
        end;
      end;
    end;
  end;
end;

procedure gen_prem(gen:generate;var task:task_rec);

const
   max_succ=5;

var i,last,left,ns:ig;
    sent:ptrprem;
    tab:succtab;
begin
 if gen.succ_g=datas then exit;
 if is_act_succ then dispose_precedence;
 with task do
 with gen do
  begin
   mix(tab,n);
   if succ_g=chain then
   begin
   for i:=1 to n-1 do
   with task_v[tab[i]]^ do
    begin
     new(next);
     next^.nrprem:=tab[i+1];
     next^.next:=nil;
    end;
    HuConstrain:=chain;
   end;
   if (succ_g=intree) or (succ_g=outtree) then
    begin
     left:=n-1;
     last:=1;
     while left>0 do
      begin
       ns:=1+trunc(max_succ*rnd01);
       if ns>left then ns:=left;
       if succ_g=outtree then
        begin
         HuConstrain:=outtree;
         task_v[tab[last]]^.next:=nil;
         for i:=1 to ns do
         with task_v[tab[last]]^ do
          begin
           new(sent);
           sent^.next:=next;
           next:=sent;
           sent^.nrprem:=tab[n+1-left];
           left:=left-1;
          end;
        end
       else  { intree }
       for i:=1 to ns do
       begin
       with task_v[tab[n+1-left]]^ do
        begin
         new(next);
         next^.nrprem:=tab[last];
         next^.next:=nil;
         left:=left-1;
        end;
        HuConstrain:=intree;
       end;
       last:=last+1;
      end;
    end;
  end;
 is_act_succ:=true;
end;



procedure generate_data;
begin
 is_act_data:=false;
 if is_act_descr then
  begin
   gen_proc(gen.speed_g,comp,kp);
   gen_task(gen,tasks,comp.nr_comp_proc,kp);
   gen_prem(gen,tasks);
  end;
 is_act_data:=(is_act_task) and (is_act_proc) and ((gen.succ_g=nosucc) or ((gen.succ_g<>nosucc) and (is_act_succ)))
end;




function generator(how:gendatatype; par:real):real;
begin
 case how of
  rnd1 : generator:=rnd01;
  rndnorm : generator:=abs(rnd_norm);
  rndexp : generator:=abs(rnd_exp(par));
 end;
end;


procedure mix(var tab:succtab; n:ig);
var
   take:array[1..MaxN] of boolean;
   i,x:ig;

begin
   for i:=1 to n do
      take[i]:=FALSE;
   for i:=1 to n do
   begin
      x:=1+trunc(rnd01*n);
      while take[x]=TRUE do
      begin
         x:=x+1;
         if x>n then x:=1;
      end;
      tab[i]:=x;
      take[x]:=TRUE;
   end;
end;


{begin
     rndnum:=0.123456789;}
end.
