{$I PCoptions}

unit Tools;

{$C MOVEABLE,PRELOAD,DISCARDABLE}

interface
uses Deklar,WinDos,OWindows,WinProcs,WinTypes;

function getsec(hr,mn,sc,sc100:ig):real;
{ Returns time in secs until now from the moment given inhr,mn,sc,sc100}

procedure initsched(var sched:schedul_rst; speed:ig; m:ig);
{ This procedure initializes data structure sched containing computed
  schedule. m- is number of processors, speed - is a speed of processors}

procedure resetsched(var sched:schedul_rst; speed:ig; m:ig);

function cardinality(a:fs):integer;
{ Returns cardinality of the set a}

procedure printset(var f:text;a:fs);
{ Prints contents of set a to file f}

function readset(var s:string;var a:fs):integer;
{ Reads set a from first the word of the string s, deletes first word from s.
  This first word to be the correct set may have only ","s or ".."s as separators
  of elements of the set. Blank space finishes set. Returns 0 if a is read
  correctly -1 if not}

function emptyp(a:string):boolean;
{ Returns true if string is empty (has only spaces or tabulations)}

function bf(a:string):string;
{ Returns string without the first word }

function first(a:string):string;
{ Returns first word from the string }

function minr(a,b:real):real;


function memP(amount:longint):Boolean;

procedure init_data_structures;
{ Initializes all scheduling data structures:
    sched:Schedul_rst;
    task:task_rec;
    comp:comp_rec;}

procedure dispose_precedence;

procedure dispose_data_structures;

procedure valr(var s:String; var x:real; var j:ig);

procedure vali(var s:String; var x:ig; var j:ig);

procedure WriteData1(var tx:text;dat: String);

procedure WriteData2(var tx:text; dat1: Real; dat2: String);

procedure WriteData3(var tx:text;dat1: String;dat2: ig; dat3: String);




implementation


function getsec(hr,mn,sc,sc100:ig):real;
var thr,tmn,tsc,tsc100:word;
    a: real;
begin
     gettime(thr,tmn,tsc,tsc100);
     a:=(thr-hr)*3600+(tmn-mn)*60+tsc-sc+((tsc100-sc100)/100);
     getsec:=(thr-hr)*3600+(tmn-mn)*60+tsc-sc+((tsc100-sc100)/100);
end;



procedure initsched(var sched:schedul_rst; speed:ig; m:ig);
{ This procedure initializes data structure sched containing computed
  schedule. m- is number of processors, speed - is a speed of processors}
var
 i :ig;
begin
 sched.m:=m;
 sched.lmax:=0;
 for i:=1 to m do
 begin
  new(sched.schedul[i]);
  with sched.schedul[i]^ do
   begin
    end_time:=0;
    nrts:=0;
    pr_speed:=speed;
   end;
 end;
end;

procedure resetsched(var sched:schedul_rst; speed:ig; m:ig);
{ This procedure initializes data structure sched containing computed
  schedule. m- is number of processors, speed - is a speed of processors}
var
 i :ig;
begin
 sched.m:=m;
 for i:=1 to m do
 begin
  with sched.schedul[i]^ do
   begin
    end_time:=0;
    nrts:=0;
    pr_speed:=speed;
   end;
 end;
end;

procedure init_data_structures;
var i:ig;
begin
 is_act_task:=false;
 is_act_proc:=false;
 is_act_sch:=false;
 is_act_data:=false;
 is_act_succ:=false;
 is_act_descr:=false;
 for i:=1 to maxN do tasks.task_v[i]:=nil; {tasks}
 tasks.n:=0;
 tasks.nr_k:=0;
 for i:=1 to maxM do comp.comp_pr[i]:=nil; {processors}
 comp.nr_comp_proc:=0;
 for i:=1 to maxM do sched.schedul[i]:=nil; {schedule}
 sched.m:=0;
 sched.c:=0;
end;

procedure dispose_precedence;
var i:integer;
    nxt1,nxt2:ptrprem;

begin
 with tasks do
  begin
   for i:=1 to tasks.n do
    begin
     {nxt1:=task_v[i]^.next;}
     while task_v[i]^.next<>nil do
      begin
       nxt2:=task_v[i]^.next^.next;
       dispose(task_v[i]^.next);
       task_v[i]^.next:=nxt2;
      end;
    end;
  end;
end;

procedure dispose_data_structures;
var i:integer;
begin
 dispose_precedence;
 for i:=1 to tasks.n do dispose(tasks.task_v[i]);
 for i:=1 to comp.nr_comp_proc do dispose(comp.comp_pr[i]);
 for i:=1 to sched.m do dispose(sched.schedul[i]);
 is_act_task:=false;
 is_act_proc:=false;
 is_act_sch:=false;
 is_act_data:=false;
 is_act_succ:=false;
end;



function cardinality(a:fs):integer;
var j,i:integer;
begin
j:=0;
for i:=1 to 255 do if i in a then j:=j+1;
cardinality:=j;
end;

procedure WriteData1(var tx:text;dat: String);
 begin
  write(tx,dat);
 end;

procedure WriteData2(var tx:text;dat1: Real; dat2: String);
 begin
  write(tx,dat1:10:3,dat2);
 end;

procedure WriteData3(var tx:text;dat1: String;dat2: ig; dat3: String);
 begin
  write(tx,dat1,dat2,dat3);
 end;

procedure printset(var f:text;a:fs);
var i,j:integer;
    fl:boolean;
begin
 i:=-1;
 fl:=false;
 while (i<255) do
  begin
  i:=i+1;
  if (i in a) then
   begin
    if fl then write(f,',',i)
    else write(f,i);
    fl:=true;
    j:=i;
    while ((i<256) and (i in a)) do i:=i+1;
    if (i-2=j) then write(f,',',i-1)
    else if (i-2>j) then write(f,'..',i-1);
   end
  end;
 writeln(f,'');
end; {of print set }



function readset(var s:string;var a:fs):integer;
var b,c:string;
    ok:boolean;
    i,j,k,l:integer;
begin
 b:=first(s);
 s:=bf(s);
 a:=[];
 ok:=true;
 readset:=-1;
 if b<>'' then
  begin
   while (length(b)>0) and ok do
    begin
     i:=1;
     while (b[i]<>',') and (b[i]<>'.') and (i<=length(b)) do inc(i);
     c:=copy(b,1,i-1);
     val(c,j,k);
     if (k=0) and (j in [0..255]) then a:=a+[j]
     else ok:=false;
     if (b[i]=',') or (i>length(b)) then delete(b,1,i)
     else if (b[i]='.') and (b[i+1]<>'.') then ok:=false
     else if (b[i]='.') and (b[i+1]='.') then
      begin
       delete(b,1,i+1);
       i:=1;
       while (b[i]<>',') and (i<=length(b)) do inc(i);
       c:=copy(b,1,i-1);
       val(c,k,l);
       if (l=0) and (k in [0..255]) then for l:=j to k do a:=a+[l]
       else ok:=false;
       delete(b,1,i);
      end;
    end;
  end;
 if ok then readset:=0;
end;



function emptyp(a:string):boolean;
var i,j:byte;
    o:boolean;
begin
 i:=1;
 j:=length(a);
 o:=true;
 while (i<=j) and (o) do
  begin
   o:=a[i]=' ';
   inc(i)
  end;
 emptyp:=o;
end;


function bf(a:string):string;
begin
while (a<>'') and (a[1]=#32) do delete(a,1,1);
while (a<>'') and (a[1]<>#32) do delete(a,1,1);
while (a<>'') and (a[1]=#32) do delete(a,1,1);
bf:=a;
end;

function first(a:string):string;
var b:string;
    var i:integer;
begin
 while (a<>'') and (a[1]=#32) do delete(a,1,1);
 b:='';i:=1;
 while (a[i]<>#32) and (i<=length(a)) do
  begin
   b:=b+a[i];
   inc(i);
  end;
 first:=b;
end;

function minr(a,b:real):real;
begin
 if a>b then minr:=b else minr:=a
end;

function memP(amount:longint):boolean;
 var
   LocalHandle: THandle;
 begin
  LocalHandle:=LocalAlloc(lmem_Fixed,amount);
  if LocalHandle = 0 then
   begin
    MessageBox(0,' Not enough memory to continue, aborting program','',mb_OK+mb_IconExclamation);
    Halt;
   end
  else
   begin
    memP:=true;
    LocalFree(LocalHandle);
   end;
 end;


procedure valr(var s:String; var x:real; var j:ig);
var
   s1:String;
   i:ig;
   z:char;
begin
   i:=1;
   while (((s[i]<>' ')and (s[i]<>#0)) and (s[i]<>Chr(9)) and (i<=length(s))) do
   begin
      i:=i+1;
   end;
   s1:=copy(s,1,i-1);
   val(s1,x,j);
end;


procedure vali(var s:String; var x:ig; var j:ig);
var
   s1: String;
   i:ig;
begin
   i:=1;
   while (((s[i]<>' ')and (s[i]<>#0)) and (s[i]<>Chr(9)) and (i<=length(s))) do
   begin
      i:=i+1;
   end;
   s1:=copy(s,1,i-1);
   val(s1,x,j);
end;


end.




